#include "bgm.h"
#include "libmy/ad_arm.h"
#include "file.h"

//---------------------------------------------------------------------------
ST_BGM Bgm;


//---------------------------------------------------------------------------
EWRAM_CODE void BgmInit(void)
{
	_Memset(&Bgm, 0x00, sizeof(ST_BGM));
}
//---------------------------------------------------------------------------
EWRAM_CODE void BgmDirect(u32 no, bool isLoop)
{
	u8* pDat = FileGetMus(no);
	u32 size = FileGetSize();

	AdSetData(pDat, size, isLoop);
	AdPlay();
}
//---------------------------------------------------------------------------
EWRAM_CODE void BgmPlay(u32 no, bool isLoop)
{
	if(Bgm.no == no)
	{
		return;
	}

	BgmDirect(no, isLoop);

	Bgm.no = no;
	Bgm.isLoop = isLoop;
}
//---------------------------------------------------------------------------
EWRAM_CODE void BgmPlayRestart(void)
{
	if(Bgm.no == 0)
	{
		AdStop();
		return;
	}

	BgmDirect(Bgm.no, Bgm.isLoop);
}
//---------------------------------------------------------------------------
EWRAM_CODE void BgmStop(void)
{
	Bgm.no = 0;
	AdStop();
}
//---------------------------------------------------------------------------
EWRAM_CODE bool BgmIsEnd(void)
{
	return AdIsEnd();
}
