#include "file.h"
#include "libmy/gbfs.h"


//---------------------------------------------------------------------------
const char* const FileSceneNameTable[FILE_MAX_SCENE_NAME_CNT] = {
	"FGAK01",
	"FGAK02C",
	"FGAK02D",
	"FGAK02F",
	"FGAK02G",
	"FGAK03",
	"FGAK04",
	"FGAK05A",
	"FGAK05B",
	"FGAK05C",
	"FGAK05D",
	"FGAK05E",
	"FGAK05F",
	"FGAK06",
	"FGAK07",
	"FGAK08",
	"FGAK09",
	"FGAK10",
	"FGAK11",
	"FGAK12",
	"FGAK13",
	"FGAK14",
	"FGAK15",
	"FGAK16",
	"FGMI01",
	"FGMI02",
	"FGMI03",
	"FGMI04",
	"FGMI05",
	"FGMI06",
	"FGMI07A",
	"FGMI07B",
	"FGMI07C",
	"FGMI08",
	"FGMI09",
	"FGMI10A",
	"FGMI10B",
	"FGMI11",
	"FGMI12",
	"FGMI13",
	"FGMI14A",
	"FGMI14B",
	"FGMI15",
	"FGMI16",
	"FGMS01",
	"FGMS02",
	"FGMS03",
	"FGMS04A",
	"FGMS04B",
	"FGMS05A",
	"FGMS05B",
	"FGMS06",
	"FGMS07",
	"FGMS08",
	"FGMS09",
	"FGMS10",
	"FGMS11A",
	"FGMS11B",
	"FGMS12",
	"FGMS13",
	"FGMS14",
	"FGMS15A",
	"FGMS15B",
	"FGMS16",
	"FGMS17",
	"FGMY01",
	"FGMY03A",
	"FGMY03B",
	"FGMY03C",
	"FGMY04",
	"FGMY05",
	"FGMY06",
	"FGMY07",
	"FGMY08",
	"FGMY09",
	"FGMY11",
	"FGMY12",
	"FGMY13",
	"FGMY14",
	"FGMY15A",
	"FGMY15B",
	"FGMY15C",
	"FGMZ01",
	"FGMZ02",
	"FGMZ03",
	"FGMZ04",
	"FGMZ05A",
	"FGMZ05B",
	"FGMZ06A",
	"FGMZ06B",
	"FGMZ07",
	"FGMZ08",
	"FGMZ09A",
	"FGMZ09B",
	"FGMZ10",
	"FGMZ11",
	"FGMZ12",
	"FGMZ13",
	"FGMZ14",
	"FGMZ15",
	"FGMZ16",
	"FGRM01",
	"FGRM02A",
	"FGRM02B",
	"FGRM02E",
	"FGRM02G",
	"FGRM02GN",
	"FGRM02H",
	"FGRM02V",
	"FGRM03A",
	"FGRM03B",
	"FGRM04",
	"FGRM04S",
	"FGRM05",
	"FGRM07",
	"FGRM08A",
	"FGRM08B",
	"FGRM08C",
	"FGRM09A",
	"FGRM09B",
	"FGRM10",
	"FGRM11",
	"FGRM12",
	"FGRM13",
	"FGRM14",
	"FGRM15",
};


//---------------------------------------------------------------------------
EWRAM_CODE void FileInit(void)
{
	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetSnx(char* pStr)
{
	char buf[32];
	_Sprintf(buf, "%s.SNX", pStr);

	FileCalcToupper(buf);
	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetImg(char* pStr)
{
	char buf[32];
	_Sprintf(buf, "%s.img", pStr);

	FileCalcToupper(buf);
	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetMus(u32 num)
{
	char buf[32];
	_Sprintf(buf, "tr_%03d.8ad", num);

	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u32 FileGetSize(void)
{
	return GbfsGetFileSize();
}
//---------------------------------------------------------------------------
EWRAM_CODE char* FileGetSceneName(u32 num)
{
	_ASSERT(num < FILE_MAX_SCENE_NAME_CNT);

	return (char*)FileSceneNameTable[num];
}
//---------------------------------------------------------------------------
EWRAM_CODE void FileCalcToupper(char* pStr)
{
	u32 i = 0;

	while(pStr[i] != '.')
	{
		pStr[i] = _Toupper(pStr[i]);
		i++;
	}
}
