#ifndef __IMG_H__
#define __IMG_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define IMG_MAX_CHR_CNT			2
#define IMG_MAX_POS_CNT			3
#define IMG_MAX_STR_SIZE		16

// TODO  GtFNg8

enum {
	IMG_EFFECT_UD    = 5,			// と
	IMG_EFFECT_MASK  = 6,			// 킶
	IMG_EFFECT_LR    = 7,			// E
	IMG_EFFECT_ALPHA = 8,			// At@uhRs[

	IMG_EFFECT_NORMAL = 0x100,		// P\
	IMG_EFFECT_END,
};


//---------------------------------------------------------------------------

typedef struct {
	bool isDraw;
	u32  effectStep;
	u32  effectNo;

	char bgStr[IMG_MAX_STR_SIZE];

	char chrStr[IMG_MAX_CHR_CNT][IMG_MAX_STR_SIZE];
	u32  chrPos[IMG_MAX_CHR_CNT];

} ST_IMG;


typedef struct {
	u16 cx;
	u16 cy;
	u16 lzFlag;
	u16 dummy;
} __PACKED ST_IMG_HEADER;

//---------------------------------------------------------------------------
EWRAM_CODE void ImgInit(void);

IWRAM_CODE void ImgExec(void);
IWRAM_CODE void ImgExecBuf(void);
IWRAM_CODE void ImgExecEffectUd(void);
IWRAM_CODE void ImgExecEffectLr(void);
IWRAM_CODE void ImgExecEffectMask(void);
IWRAM_CODE void ImgExecEffectNormal(void);

EWRAM_CODE void ImgDrawBg(char* pStr);
EWRAM_CODE void ImgDrawChr(char* pStr, u32 pos);
EWRAM_CODE void ImgDrawCircle(u32 sx, u32 sy);

EWRAM_CODE void ImgSetBg(char* pStr);
EWRAM_CODE void ImgSetBgClear(void);
EWRAM_CODE void ImgSetChr(char* pStr, u32 no, u32 pos);
EWRAM_CODE void ImgSetChrClear(void);
EWRAM_CODE void ImgSetEffect(u32 no);
EWRAM_CODE void ImgSetDraw(void);

EWRAM_CODE void ImgDirect(char* pStr);
EWRAM_CODE bool ImgIsEnd(void);


#ifdef __cplusplus
}
#endif
#endif
