#ifndef __FADE_H__
#define __FADE_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "../libgba/gba.h"


//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
typedef struct {
	bool isEnd;
	s32  cnt;
	s32  end;
	s32  change;
	s32  wait;
	s32  waitCnt;

	u32  msg;
} ST_FADE;


//---------------------------------------------------------------------------
EWRAM_CODE void FadeInit(void);
EWRAM_CODE void FadeExec(void);

EWRAM_CODE void FadeSetDefault(u32 mode, u32 wait);
EWRAM_CODE void FadeSetDrakIn(u32 wait);
EWRAM_CODE void FadeSetDrakOut(u32 wait);
EWRAM_CODE void FadeSetLightIn(u32 wait);
EWRAM_CODE void FadeSetLightOut(u32 wait);
EWRAM_CODE u32  FadeGetMsgFade(void);


EWRAM_CODE void FadeDirect(u32 num);
EWRAM_CODE bool FadeIsEnd(void);


#ifdef __cplusplus
}
#endif
#endif
