#include "key.h"


//---------------------------------------------------------------------------
ST_KEY Key;


//---------------------------------------------------------------------------
EWRAM_CODE void KeyInit(void)
{
	_Memset(&Key, 0x00, sizeof(ST_KEY));

	Key.tmp[SYS_KEY_A]  = KEY_A;
	Key.tmp[SYS_KEY_B]  = KEY_B;
	Key.tmp[SYS_KEY_SL] = KEY_SELECT;
	Key.tmp[SYS_KEY_ST] = KEY_START;
	Key.tmp[SYS_KEY_RI] = KEY_RIGHT;
	Key.tmp[SYS_KEY_LE] = KEY_LEFT;
	Key.tmp[SYS_KEY_UP] = KEY_UP;
	Key.tmp[SYS_KEY_DO] = KEY_DOWN;
	Key.tmp[SYS_KEY_R]  = KEY_R;
	Key.tmp[SYS_KEY_L]  = KEY_L;
}
//---------------------------------------------------------------------------
// vblank1񂾂Ăяo܂i`^Oh~j
IWRAM_CODE void KeyExec(void)
{
	u32 inkey = REG_KEYINPUT;
	u32 cnt   = 0;

	if(inkey & Key.tmp[SYS_KEY_A])  cnt += KEY_A;
	if(inkey & Key.tmp[SYS_KEY_B])  cnt += KEY_B;
	if(inkey & Key.tmp[SYS_KEY_SL]) cnt += KEY_SELECT;
	if(inkey & Key.tmp[SYS_KEY_ST]) cnt += KEY_START;
	if(inkey & Key.tmp[SYS_KEY_RI]) cnt += KEY_RIGHT;
	if(inkey & Key.tmp[SYS_KEY_LE]) cnt += KEY_LEFT;
	if(inkey & Key.tmp[SYS_KEY_UP]) cnt += KEY_UP;
	if(inkey & Key.tmp[SYS_KEY_DO]) cnt += KEY_DOWN;
	if(inkey & Key.tmp[SYS_KEY_R])  cnt += KEY_R;
	if(inkey & Key.tmp[SYS_KEY_L])  cnt += KEY_L;

	cnt     = ~cnt;
	Key.trg = (Key.trg ^ cnt) & ~Key.cnt;
	Key.off = ~cnt & Key.cnt;
	Key.cnt = cnt;


	// L[s[g
	if(Key.trg & DPAD || Key.repCnt == 0)
	{
		Key.rep = Key.cnt;
		Key.repCnt = KEY_REPEAT_CNT;
	}
	else
	{
		Key.rep = 0;
	}

	if(Key.cnt & DPAD)
	{
		if(Key.repCnt != 0) Key.repCnt--;
	}
	else
	{
		Key.repCnt = 0;
	}
}
//---------------------------------------------------------------------------
// ݉Ă{^
EWRAM_CODE u16 KeyGetCnt(void)
{
	return Key.cnt;
}
//---------------------------------------------------------------------------
// ꂽ̃{^
EWRAM_CODE u16 KeyGetTrg(void)
{
	return Key.trg;
}
//---------------------------------------------------------------------------
// ꂽ̃{^
EWRAM_CODE u16 KeyGetOff(void)
{
	return Key.off;
}
//---------------------------------------------------------------------------
// L[s[g̃{^B\L[̂ݑΉ
EWRAM_CODE u16 KeyGetRep(void)
{
	return Key.rep;
}
//---------------------------------------------------------------------------
EWRAM_CODE bool KeyIsCntAB(void)
{
	return (Key.cnt & (KEY_A | KEY_B)) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE bool KeyIsTrgAB(void)
{
	return (Key.trg & (KEY_A | KEY_B)) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE bool KeyChangeBotton(u32 b1, u32 b2)
{
	if(b1 > KEY_MAX_BTN_CNT)
	{
		return FALSE;
	}

	Key.tmp[b1] = b2;

	return TRUE;
}
