#ifndef __MODE3_H__
#define __MODE3_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "../libgba/gba.h"

//---------------------------------------------------------------------------
#define MODE3_MAX_BUF_SIZE			(SCREEN_WIDTH * SCREEN_HEIGHT * 2)


//---------------------------------------------------------------------------
typedef struct {
	bool isDraw;
	u16  bg[MODE3_MAX_BUF_SIZE/2] ALIGN(4);
	u16  chr[MODE3_MAX_BUF_SIZE/2] ALIGN(4);

} ST_MODE3;


//---------------------------------------------------------------------------
EWRAM_CODE void Mode3Init(void);
IWRAM_CODE void Mode3Exec(void);

IWRAM_CODE void Mode3DrawBg(u16* pBuf);
IWRAM_CODE void Mode3DrawBgFill(u16 col);
IWRAM_CODE void Mode3DrawBgClear(void);
IWRAM_CODE void Mode3DrawImg(u32 sx, u32 sy, u32 cx, u32 cy, u16* img);
IWRAM_CODE void Mode3DrawImgMask(u32 sx, u32 sy, u32 cx, u32 cy, u16* img, u16 mask);
IWRAM_CODE void Mode3DrawCircle(u32 sx, u32 sy, u32 rad, u16 col);
IWRAM_CODE void Mode3Copy(u32 sx, u32 sy, u32 cx, u32 cy);

EWRAM_CODE void Mode3SetDraw(bool isDraw);


#ifdef __cplusplus
}
#endif
#endif
