#ifndef __MENU_H__
#define __MENU_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define MENU_MAX_STR_LEN					(17*2+2)
#define MENU_MAX_ITEM_CNT					8


enum {
	MENU_ACT_READY = 0x01,
	MENU_ACT_DRAW,
	MENU_ACT_SELECT,
	MENU_ACT_SELECTED,
	MENU_ACT_END_READY,
	MENU_ACT_END,
};

enum {
	MENU_TYPE_NORMAL = 0x01,
	MENU_TYPE_OPTION,
};

enum {
	MENU_RET_TITLE = 0x01,
	MENU_RET_SYSTEM,
};

//---------------------------------------------------------------------------

typedef struct {
	u32  cnt;
	char str[MENU_MAX_STR_LEN] ALIGN(4);
	void (*pFunc)(void);
} ST_MENU_ITEM;


typedef struct {
	u32  act;
	u32  actStep;
	u32  sx;										// zuW
	u32  sy;

	u32  type;										// j[̎
	s32  sel;										// I𒆂̏ꏊ
	u32  ret;										// \Kw̑ޔp
	s32  regCnt;									// I̓o^
	bool isCancel;									// LZ̗L
	char title[MENU_MAX_STR_LEN] ALIGN(4);			// ^Cg
	ST_MENU_ITEM item[MENU_MAX_ITEM_CNT] ALIGN(4);	// ACe

	u32  trg;
} ST_MENU;


//---------------------------------------------------------------------------
EWRAM_CODE void MenuInit(void);
EWRAM_CODE void MenuExec(void);
EWRAM_CODE void MenuExecDraw(void);
EWRAM_CODE void MenuExecDrawNormal(void);
EWRAM_CODE void MenuExecDrawOption(void);
EWRAM_CODE void MenuExecSelect(void);
EWRAM_CODE void MenuExecSelected(void);
EWRAM_CODE bool MenuIsEnd(void);

EWRAM_CODE void MenuSetAct(u32 act);
EWRAM_CODE void MenuSetOption(u32 sx, u32 sy, char* pTitle, u32 type, bool isCancel);
EWRAM_CODE void MenuAddItem(char* pStr, void* pFunc);

EWRAM_CODE void MenuSetTitle(void);
EWRAM_CODE void MenuSetSystem(void);
EWRAM_CODE void MenuSetSystemOption(void);
EWRAM_CODE void MenuSetSave(void);
EWRAM_CODE void MenuSetLoad(void);


EWRAM_CODE void MenuItem0Start(void);
EWRAM_CODE void MenuItem0Load(void);
EWRAM_CODE void MenuItem1Next(void);
EWRAM_CODE void MenuItem1TextHide(void);
EWRAM_CODE void MenuItem1Ref(void);
EWRAM_CODE void MenuItem1Save(void);
EWRAM_CODE void MenuItem1Load(void);
EWRAM_CODE void MenuItem1Option(void);
EWRAM_CODE void MenuItem1GameEnd(void);
EWRAM_CODE void MenuItem2TextWait(void);
EWRAM_CODE void MenuItem2Fade(void);
EWRAM_CODE void MenuItem2Bgm(void);
EWRAM_CODE void MenuItem2Scene(void);
EWRAM_CODE void MenuItem3SaveSiori(void);
EWRAM_CODE void MenuItem3LoadSiori(void);


#ifdef __cplusplus
}
#endif
#endif
