#ifndef __NV_H__
#define __NV_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define NV_MAX_VAR_CNT					256
#define NV_MAX_MSG_STR_SIZE				256
#define NV_MAX_STR_SIZE					16

#define NV_MAX_SEL_CNT					5
#define NV_MAX_SEL_STR_SIZE				64
#define NV_MAX_CALL_CNT					16


enum {
	NV_ACT_PARSE = 0x01,
	NV_ACT_KEY,
	NV_ACT_KEY_WAIT,
	NV_ACT_CALENDAR,
	NV_ACT_SELECT,
	NV_ACT_END,
};

//---------------------------------------------------------------------------

typedef struct {
	// 
	u32  act;
	u32  actStep;
	s32  wait;
	bool isLoop;
	bool isSkip;					// bZ[WGtFNgXLbv

	// XNvgt@C
	u8*  pHead;						// wb_ʒu
	u8*  pCur;						// J[\
	char str[NV_MAX_STR_SIZE];		// t@C
	u32  size;						// t@CTCY

	// ϐ
	u8   varSystem[NV_MAX_VAR_CNT];
	u8   varSwitch[NV_MAX_VAR_CNT];
	u8   varCount[NV_MAX_VAR_CNT];

	// bZ[W
	s32  msgCnt;
	u8   msgStr[NV_MAX_MSG_STR_SIZE] ALIGN(4);

	// I
	s32  sel;						// [UIĂ鍀
	s32  selCnt;					// o^
	u32  selIdx;					// ʂԂtOԍivarCountƑΉj
	u8   selStr[NV_MAX_SEL_CNT][NV_MAX_SEL_STR_SIZE] ALIGN(4);

	// XNvgR[
	s32  callCnt;
	u32  callAdr[NV_MAX_CALL_CNT];
	char callStr[NV_MAX_CALL_CNT][NV_MAX_STR_SIZE];
} ST_NV;


//---------------------------------------------------------------------------
EWRAM_CODE void NvInit(void);
EWRAM_CODE void NvInitVar(void);

EWRAM_CODE void NvExec(void);
EWRAM_CODE void NvExecKey(void);
EWRAM_CODE bool NvExecKeySub(void);
EWRAM_CODE void NvExecKeyWait(void);
EWRAM_CODE void NvExecCalendar(void);
EWRAM_CODE void NvExecSelect(void);

EWRAM_CODE void NvSetAct(u32 act);
EWRAM_CODE void NvSetSnx(char* pStr);
EWRAM_CODE void NvSetSkip(bool is);

EWRAM_CODE void NvSetVarSystem(u32 idx, u8 val);
EWRAM_CODE void NvSetVarSwitch(u32 idx, u8 val);
EWRAM_CODE void NvSetVarCount(u32 idx, u8 val);
EWRAM_CODE u8   NvGetVarSystem(u32 idx);
EWRAM_CODE u8   NvGetVarSwitch(u32 idx);
EWRAM_CODE u8   NvGetVarCount(u32 idx);

EWRAM_CODE bool NvIsEnd(void);


#ifdef __cplusplus
}
#endif
#endif
