#include "nv2.h"
#include "nv.h"
#include "img.h"
#include "text.h"
#include "bgm.h"
#include "menu.h"
#include "history.h"


//---------------------------------------------------------------------------
u8 NvKanaToSjisTable[0x60] = {
	0x40, 0x49, 0x68, 0x94, 0x90, 0x93, 0x95, 0x66, 0x69, 0x6a, 0x96, 0x7b, 0x43, 0x7c, 0x44, 0x5e,
	0x4f, 0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x46, 0x47, 0x83, 0x81, 0x84, 0x48,
	0x97, 0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e,
	0x6f, 0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x6d, 0x8f, 0x6e, 0x4f, 0x51,
	0x65, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x8a, 0x8b, 0x8c, 0x8d, 0x8e, 0x8f,
	0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99, 0x9a, 0x6f, 0x62, 0x70, 0x60, 0x45
};


//---------------------------------------------------------------------------
extern ST_NV Nv;


//---------------------------------------------------------------------------
IWRAM_CODE void NvExecParse(void)
{
	if(Nv.wait != 0)
	{
		Nv.wait--;
		return;
	}


	Nv.isLoop = TRUE;

	do
	{
		NvExecParseSub();

	} while(Nv.isLoop == TRUE);
}
//---------------------------------------------------------------------------
IWRAM_CODE void NvExecParseSub(void)
{
	TRACEOUT("----\n");
	TRACEOUT("[cmd:%x pCur:%x file:%s.SNX]\n", *Nv.pCur, Nv.pCur - Nv.pHead, Nv.str);

	switch(*Nv.pCur++)
	{
	case 0x00:
		NvExecParse00();
		break;

	case 0x04:
		NvExecParse04();
		break;

	case 0x08:
		NvExecParse08();
		break;

	case 0x0c:
		NvExecParse0c();
		break;

	case 0x10:
		NvExecParse10();
		break;

	case 0x11:
		NvExecParse11();
		break;

	case 0x15:
		NvExecParse15();
		break;

	case 0x17:
		NvExecParse17();
		break;

	case 0x18:
		NvExecParse18();
		break;

	case 0x19:
		NvExecParse19();
		break;

	case 0x1a:
		NvExecParse1a();
		break;

	case 0x28:
		NvExecParse28();
		break;

	case 0x64:
		NvExecParse64();
		break;

	case 0x65:
		NvExecParse65();
		break;

	case 0x66:
		NvExecParse66();
		break;

	case 0x67:
		NvExecParse67();
		break;

	case 0x69:
		NvExecParse69();
		break;

	case 0x6a:
		NvExecParse6a();
		break;

	case 0x6b:
		NvExecParse6b();
		break;

	case 0x6c:
		NvExecParse6c();
		break;

	case 0x6d:
		NvExecParse6d();
		break;

	case 0x6e:
		NvExecParse6e();
		break;

	case 0x71:
		NvExecParse71();
		break;

	case 0x72:
		NvExecParse72();
		break;

	case 0x74:
		NvExecParse74();
		break;

	case 0x75:
		NvExecParse75();
		break;

	case 0x76:
		NvExecParse76();
		break;

	case 0x77:
		NvExecParse77();
		break;

	case 0x78:
		NvExecParse78();
		break;

	case 0x79:
		NvExecParse79();
		break;

	case 0x7a:
		NvExecParse7a();
		break;

	case 0x7b:
		NvExecParse7b();
		break;

	case 0x7c:
		NvExecParse7c();
		break;

	case 0x7e:
		NvExecParse7e();
		break;

	case 0x7f:
		NvExecParse7f();
		break;

	case 0x80:
		NvExecParse80();
		break;

	case 0x81:
		NvExecParse81();
		break;

	case 0x82:
		NvExecParse82();
		break;

	case 0x84:
		NvExecParse84();
		break;

	case 0xff:
		NvExecParseff();
		break;

	default:
		SystemError("[Err] NvExecParseSub\n");
		break;
	}
}
//---------------------------------------------------------------------------
// JE^Zbg
IWRAM_CODE void NvExecParse00(void)
{
	TRACEOUT("[Set Count]\n");

	u16 idx = NvCurU16();
	u16 val = NvCurU16();

	NvSetVarCount(idx, val);
}
//---------------------------------------------------------------------------
// JE^Zbg
IWRAM_CODE void NvExecParse04(void)
{
	TRACEOUT("[Set Switch]\n");

	u16 idx = NvCurU16();
	u16 val = NvCurU16();

	NvSetVarSwitch(idx, val);
}
//---------------------------------------------------------------------------
// JE^Z
IWRAM_CODE void NvExecParse08(void)
{
	TRACEOUT("[Set Count Add]\n");

	u16 idx = NvCurU16();
	u16 add = NvCurU16();
	u16 val = NvGetVarCount(idx);

	NvSetVarCount(idx, val + add);
}
//---------------------------------------------------------------------------
// JE^Z
IWRAM_CODE void NvExecParse0c(void)
{
	TRACEOUT("[Set Count Sub]\n");

	u16 idx = NvCurU16();
	u16 sub = NvCurU16();
	u16 val = NvGetVarCount(idx);

	NvSetVarCount(idx, val - sub);
}
//---------------------------------------------------------------------------
// Wv
IWRAM_CODE void NvExecParse10(void)
{
	TRACEOUT("[Jump]\n");

	Nv.pCur = Nv.pHead + NvCurU16();
}
//---------------------------------------------------------------------------
// 
IWRAM_CODE void NvExecParse11(void)
{
	TRACEOUT("[Assign]\n");

	u16 arg[16];
	u16 val;
	s16 n = 0;

	for(;;)
	{
//		TRACEOUT("[cur:%x dat:%x]\n", Nv.pCur - Nv.pHead, *Nv.pCur);
		_ASSERT(n >= 0);
		_ASSERT(n <  16);

		switch(*Nv.pCur++)
		{
		case 0x00:
			val = NvCurU16();
			if(!arg[0]) Nv.pCur = Nv.pHead + val;	// sɃWv
			return;

		case 0x02:
			n--;
			if(arg[n-1] == arg[n]) arg[n-1] = 1; else arg[n-1] = 0;
			break;

		case 0x03:
			n--;
			if(arg[n-1] <  arg[n]) arg[n-1] = 1; else arg[n-1] = 0;
			break;

		case 0x04:
			n--;
			if(arg[n-1] >  arg[n]) arg[n-1] = 1; else arg[n-1] = 0;
			break;

		case 0x05:
			n--;
			if(arg[n-1] <= arg[n]) arg[n-1] = 1; else arg[n-1] = 0;
			break;

		case 0x06:
			n--;
			if(arg[n-1] >= arg[n]) arg[n-1] = 1; else arg[n-1] = 0;
			break;

		case 0x0a:
			n--;
			if(arg[n-1] || arg[n]) arg[n-1] = 1; else arg[n-1] = 0;
			break;

		case 0x0f:
			n--;
			if(arg[n-1] && arg[n]) arg[n-1] = 1; else arg[n-1] = 0;
			break;

		case 0x15:
			val = NvCurU16();
			arg[n++] = val;
			break;

		case 0x16:
			val = NvCurU16();
			arg[n++] = NvGetVarCount(val);
			break;

		case 0x17:
			val = NvCurU16();
			arg[n++] = NvGetVarSwitch(val);
			break;

		default:
			SystemError("[Err] NvExecParse11");
			break;
		}
	}
}
//---------------------------------------------------------------------------
// bZ[W
IWRAM_CODE void NvExecParse15(void)
{
	TRACEOUT("[Msg]\n");

	NvCurMsg();

	TextCalcBufWork((u16*)Nv.msgStr, Nv.msgCnt / 2);
	TextShow();

	NvSetAct(NV_ACT_KEY);
	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// I
IWRAM_CODE void NvExecParse17(void)
{
	TRACEOUT("[Sel]\n");

	Nv.selIdx = NvCurU16();		// ʂԂtOԍ
	Nv.selCnt = 0;

	do {
		NvCurMsg();
		NvSelPush();

	} while(*Nv.pCur != 0x00);

	Nv.pCur++;


	NvSetAct(NV_ACT_SELECT);
	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// XNvgւ̃Wv
IWRAM_CODE void NvExecParse18(void)
{
	TRACEOUT("[Jump SNX]\n");

	NvSetSnx((char*)Nv.pCur);
}
//---------------------------------------------------------------------------
// XNvgւ̃R[
IWRAM_CODE void NvExecParse19(void)
{
	TRACEOUT("[Call SNX]\n");

	char* pStr = (char*)Nv.pCur;
	NvCurSkipText();

	NvCallPush();
	NvSetSnx(pStr);
}
//---------------------------------------------------------------------------
// XNvgփ^[
IWRAM_CODE void NvExecParse1a(void)
{
	TRACEOUT("[Pop SNX]\n");

	NvCallPop();
}
//---------------------------------------------------------------------------
// wiǂݍ݁iXN[j
IWRAM_CODE void NvExecParse28(void)
{
	TRACEOUT("[Bg Scroll bg:%s]\n", (char*)Nv.pCur);

	ImgSetChrClear();
	ImgSetBg((char*)Nv.pCur);
	NvCurSkipText();

	NvEffect(IMG_EFFECT_LR);
	ImgSetDraw();

	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// EFCgi0.00152 * nb҂j
IWRAM_CODE void NvExecParse64(void)
{
	TRACEOUT("[Wait Short]\n");

	Nv.wait = Div(*Nv.pCur++, 11);		// vblankƓi0.001515... = (1/60) / 11j
	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// L[҂
IWRAM_CODE void NvExecParse65(void)
{
	TRACEOUT("[Wait Key]\n");

	NvSetAct(NV_ACT_KEY_WAIT);
	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// wiǂݍ݁iGtFNgj
IWRAM_CODE void NvExecParse66(void)
{
	u8 idx = *Nv.pCur++;

	TRACEOUT("[Bg + Effect bg:%s]\n", (char*)Nv.pCur);

	ImgSetChrClear();
	ImgSetBg((char*)Nv.pCur);
	NvCurSkipText();

	NvEffect(idx);
	ImgSetDraw();

	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// ubNAEgiGtFNgj
IWRAM_CODE void NvExecParse67(void)
{
	TRACEOUT("[BlackOut + Effect]\n");

	u8 idx = *Nv.pCur++;

	ImgSetBgClear();
	ImgSetChrClear();

	NvEffect(idx);
	ImgSetDraw();

	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// ubNAEgiXN[j
IWRAM_CODE void NvExecParse69(void)
{
	TRACEOUT("[BlackOut + LR]\n");

	ImgSetBgClear();
	ImgSetChrClear();

	NvEffect(IMG_EFFECT_LR);
	ImgSetDraw();

	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// L\
IWRAM_CODE void NvExecParse6a(void)
{
	u8 no  = *Nv.pCur++;
	u8 pos = *Nv.pCur++;

	TRACEOUT("[Chr Disp no:%d pos:%d chr:%s]\n", no, pos, (char*)Nv.pCur);

	ImgSetChr((char*)Nv.pCur, no, pos);
	NvCurSkipText();

	NvEffect(IMG_EFFECT_MASK);
	ImgSetDraw();

	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// LύX
IWRAM_CODE void NvExecParse6b(void)
{
	u8 no  = *Nv.pCur++;
	u8 pos = *Nv.pCur++;

	TRACEOUT("[Chr Change no:%d pos:%d chr:%s]\n", no, pos, (char*)Nv.pCur);

	ImgSetChr((char*)Nv.pCur, no, pos);
	NvCurSkipText();

	NvEffect(IMG_EFFECT_MASK);
	ImgSetDraw();

	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// L
IWRAM_CODE void NvExecParse6c(void)
{
	u8 no = *Nv.pCur++;

	TRACEOUT("[Chr Delete no:%d]\n", no);

	if(no > 1)
	{
		ImgSetChrClear();
	}
	else
	{
		ImgSetChr("", no, 0);
	}

	NvEffect(IMG_EFFECT_MASK);
	ImgSetDraw();

	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// BGMĐ
IWRAM_CODE void NvExecParse6d(void)
{
	u8 no   = *Nv.pCur++;
	u8 loop = *Nv.pCur++;

	TRACEOUT("[Bgm no:%d loop:%d]\n", no, loop);

	if(loop == 0)
	{
		BgmPlay(no, FALSE);
	}
	else
	{
		BgmPlay(no, TRUE);
	}
}
//---------------------------------------------------------------------------
// BGM~
IWRAM_CODE void NvExecParse6e(void)
{
	TRACEOUT("[Bgm Stop]\n");

	// skip fade
	Nv.pCur++;

	BgmStop();
}
//---------------------------------------------------------------------------
// t\iEɃtF[hC\Ab\tF[hAEgj
IWRAM_CODE void NvExecParse71(void)
{
	TRACEOUT("[Date]\n");

	// EMPTY
}
//---------------------------------------------------------------------------
// O
IWRAM_CODE void NvExecParse72(void)
{
	TRACEOUT("[Name]\n");

	u8 idx = *Nv.pCur++;
	NvSetVarCount(idx, 0);
}
//---------------------------------------------------------------------------
// WaitXLbvL薳̕ύX
IWRAM_CODE void NvExecParse74(void)
{
	TRACEOUT("[Skip Change]\n");

	// EMPTY
	Nv.pCur++;
}
//---------------------------------------------------------------------------
// H
IWRAM_CODE void NvExecParse75(void)
{
	TRACEOUT("[Dummy 75]\n");

	// EMPTY
	Nv.pCur++;
}
//---------------------------------------------------------------------------
// EFCgi0.1 * n(b)҂j
IWRAM_CODE void NvExecParse76(void)
{
	TRACEOUT("[Wait Long]\n");

	Nv.wait = (*Nv.pCur++) * 6;		// vblankƓi0.1 = (1/60) * 6j
	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// VXetOZbg
IWRAM_CODE void NvExecParse77(void)
{
	TRACEOUT("[Set System]\n");

	u8 idx = *Nv.pCur++;
	u8 val = *Nv.pCur++;

	NvSetVarSystem(idx, val);
}
//---------------------------------------------------------------------------
// VXetO擾iJE^tOɓj
IWRAM_CODE void NvExecParse78(void)
{
	TRACEOUT("[Set Count]\n");

	u8 idxs = *Nv.pCur++;
	u8 idxc = *Nv.pCur++;
	u8 val  = NvGetVarSystem(idxs);

	NvSetVarCount(idxc, val);
}
//---------------------------------------------------------------------------
// u^Cgɖ߂vp̃|C^ݒ
IWRAM_CODE void NvExecParse79(void)
{
	TRACEOUT("[Title Prev]\n");

	// EMPTY
}
//---------------------------------------------------------------------------
// ^Cgj[I
IWRAM_CODE void NvExecParse7a(void)
{
	TRACEOUT("[Title Sel]\n");

	HistoryInit();
	TextInit();
	NvInitVar();
	NvSetSkip(FALSE);

	ImgSetBg("ETC00");
	ImgSetEffect(IMG_EFFECT_MASK);
	ImgSetDraw();

	TextShow();
	MenuSetTitle();

	Nv.pCur = Nv.pHead + 0x38;		// O͂΂܂
	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// H
IWRAM_CODE void NvExecParse7b(void)
{
	TRACEOUT("[Dummy 7b]\n");

	// EMPTY
}
//---------------------------------------------------------------------------
// [hX^[g̃t@CI
IWRAM_CODE void NvExecParse7c(void)
{
	TRACEOUT("[Load]\n");

	// EMPTY
}
//---------------------------------------------------------------------------
// Special̃j[I
IWRAM_CODE void NvExecParse7e(void)
{
	TRACEOUT("[Special Menu]\n");

	// EMPTY
	Nv.pCur++;
}
//---------------------------------------------------------------------------
// j[iIj
IWRAM_CODE void NvExecParse7f(void)
{
	TRACEOUT("[Special End]\n");

	// EMPTY
}
//---------------------------------------------------------------------------
// CG[hł̃LI
IWRAM_CODE void NvExecParse80(void)
{
	TRACEOUT("[CgChr Select]\n");

	// EMPTY
	Nv.pCur++;
}
//---------------------------------------------------------------------------
// CG[hł̃OtBbNI
IWRAM_CODE void NvExecParse81(void)
{
	TRACEOUT("[CgMode Select]\n");

	// EMPTY
	Nv.pCur++;
}
//---------------------------------------------------------------------------
// BGM[hł̋ȑI
IWRAM_CODE void NvExecParse82(void)
{
	TRACEOUT("[BgmMode Select]\n");

	// EMPTY
	Nv.pCur++;
}
//---------------------------------------------------------------------------
// J_[\
IWRAM_CODE void NvExecParse84(void)
{
	TRACEOUT("[Calendar]\n");

	NvSetAct(NV_ACT_CALENDAR);
	Nv.isLoop = FALSE;
}
//---------------------------------------------------------------------------
// XNvg̏I
IWRAM_CODE void NvExecParseff(void)
{
	TRACEOUT("[End]\n");

	// EMPTY
}
//---------------------------------------------------------------------------
IWRAM_CODE u16 NvCurU16(void)
{
	u16 ret = 0;

	ret |= (*Nv.pCur++);
	ret |= (*Nv.pCur++) << 8;

	return ret;
}
//---------------------------------------------------------------------------
IWRAM_CODE void NvCurSkipText(void)
{
	while(*Nv.pCur++ != 0x00)
	{
		// EMPTY
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void NvCurMsg(void)
{
	Nv.msgCnt = 0;

	for(;;)
	{
//		TRACEOUT("[w:%x pCur:%x cnt:%x]\n", *Nv.pCur, Nv.pCur - Nv.pHead, Nv.msgCnt);

		if(*Nv.pCur == 0x00)
		{
			Nv.pCur++;

			Nv.msgStr[Nv.msgCnt] = '\0';
			TRACEOUT("[%s]\n", Nv.msgStr);

			_ASSERT(Nv.msgCnt+1 < NV_MAX_MSG_STR_SIZE);
			return;
		}

		// CR, Window Draw/Clear, Click Wait
		if(*Nv.pCur == 0x01 || *Nv.pCur == 0x02 || *Nv.pCur == 0x05)
		{
			Nv.pCur++;
			continue;
		}

		// Sp
		if(*Nv.pCur >= 0x80)
		{
			Nv.msgStr[Nv.msgCnt++] = *Nv.pCur++;
			Nv.msgStr[Nv.msgCnt++] = *Nv.pCur++;

			continue;
		}

		// Oi_j
		if(*Nv.pCur == 0x10)
		{
			Nv.msgStr[Nv.msgCnt++] = 0x8d;
			Nv.msgStr[Nv.msgCnt++] = 0x5f;
			Nv.msgStr[Nv.msgCnt++] = 0x95;
			Nv.msgStr[Nv.msgCnt++] = 0xbd;
			Nv.pCur++;

			continue;
		}

		// ci܌j
		if(*Nv.pCur == 0x11)
		{
			Nv.msgStr[Nv.msgCnt++] = 0x90;
			Nv.msgStr[Nv.msgCnt++] = 0xdc;
			Nv.msgStr[Nv.msgCnt++] = 0x8c;
			Nv.msgStr[Nv.msgCnt++] = 0xb4;
			Nv.pCur++;

			continue;
		}

		// p
		if(*Nv.pCur >= 0x20)
		{
			u8 c = *Nv.pCur++;

			if(((c >= '0') && (c <= '9')) || ((c >= 'A') && (c <= 'Z')) || ((c >= 'a') && (c <= 'z')))
			{
				Nv.msgStr[Nv.msgCnt++] = 0x82;
			}
			else
			{
				Nv.msgStr[Nv.msgCnt++] = 0x81;
			}

			Nv.msgStr[Nv.msgCnt++] = NvKanaToSjisTable[c - 0x20];
			continue;
		}

		SystemError("[Err] NvCurMsg");

	} // for
}
//---------------------------------------------------------------------------
IWRAM_CODE void NvSelPush(void)
{
	_ASSERT(Nv.selCnt < NV_MAX_SEL_CNT);

	_Strncpy((char*)Nv.selStr[Nv.selCnt], (char*)Nv.msgStr, NV_MAX_SEL_STR_SIZE);
	Nv.selStr[Nv.selCnt][17*2] = '\0';		// 17

	Nv.selCnt++;
}
//---------------------------------------------------------------------------
IWRAM_CODE void NvCallPush(void)
{
	_ASSERT(Nv.callCnt < NV_MAX_CALL_CNT);

	Nv.callAdr[Nv.callCnt] = Nv.pCur - Nv.pHead;
	_Strncpy(Nv.callStr[Nv.callCnt], Nv.str, NV_MAX_STR_SIZE);

	Nv.callCnt++;
}
//---------------------------------------------------------------------------
IWRAM_CODE void NvCallPop(void)
{
	_ASSERT(Nv.callCnt != 0);
	Nv.callCnt--;

	NvSetSnx(Nv.callStr[Nv.callCnt]);
	Nv.pCur += Nv.callAdr[Nv.callCnt];
}
//---------------------------------------------------------------------------
IWRAM_CODE void NvEffect(u32 idx)
{
	TextHide();
	TextClear();

	if(Nv.isSkip == FALSE)
	{
		ImgSetEffect(idx);
	}
	else
	{
		ImgSetEffect(IMG_EFFECT_NORMAL);
	}
}
