#ifndef __TEXT_H__
#define __TEXT_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define TEXT_SCREEN_CX					17
#define TEXT_SCREEN_CY					10

#define TEXT_CURSOR_WSX					18
#define TEXT_CURSOR_WSY					22
#define TEXT_CURSOR_WAIT_CNT			10		// vblankƓĂ܂

#define TEXT_SIORI_CX					12


//---------------------------------------------------------------------------

typedef struct {
	bool isDraw;				// eLXg̕`tO
	bool isWrite;				// eLXg̏݃tOi2xh~pj

	u32  waitNum;				// \̃EFCg
	u32  waitCnt;				// `EFCg
	u32  drawCnt;				// JEg

	u32  x;
	u32  y;

	bool isCurDraw;
	bool isCurBlink;
	u32  curWaitCnt;

	// ֑[Nobt@
	u16  workBuf[TEXT_SCREEN_CX * TEXT_SCREEN_CY] ALIGN(4);
	u32  workCnt;

	// ޔp̕R[hobt@
	u16  outBuf[TEXT_SCREEN_CX * TEXT_SCREEN_CY] ALIGN(4);

	// pobt@
	u16  sioriBuf[TEXT_SIORI_CX] ALIGN(4);
} ST_TEXT;


//---------------------------------------------------------------------------
EWRAM_CODE void TextInit(void);
EWRAM_CODE void TextExec(void);
EWRAM_CODE void TextExecChr(void);
EWRAM_CODE void TextExecCur(void);

EWRAM_CODE void TextShow(void);
EWRAM_CODE void TextHide(void);
EWRAM_CODE void TextShowCur(void);
EWRAM_CODE void TextHideCur(void);

EWRAM_CODE void TextClear(void);
EWRAM_CODE void TextClearBuf(void);
EWRAM_CODE void TextClearDat(void);
EWRAM_CODE void TextClearXY(void);
EWRAM_CODE void TextSetLf(void);

IWRAM_CODE void TextCalcBufWork(u16* pStr, u32 len);
IWRAM_CODE void TextSetBufSiori(u16* pStr, u32 len);
EWRAM_CODE u16* TextGetBufSiori(void);
EWRAM_CODE void TextSetWaitNum(u32 num);
EWRAM_CODE u32  TextGetWaitNum(void);

IWRAM_CODE bool TextCalcStrBoundary(u16* pSrc, u32 len);
IWRAM_CODE bool TextIsChrBoundaryBefore(u16 code);
IWRAM_CODE bool TextIsChrBoundaryAfter(u16 code);

IWRAM_CODE void TextDrawChr(u16 code, bool isBuf);
IWRAM_CODE void TextDrawStr(u16* pStr, u32 len, bool isBuf);
IWRAM_CODE void TextDrawStrXy(u32 x, u32 y, u16* pStr);
IWRAM_CODE void TextDrawStrXyGray(u32 x, u32 y, u16* pStr);
IWRAM_CODE void TextDrawFull(u16* pStr);
IWRAM_CODE void TextDrawFullGray(u16* pStr);
IWRAM_CODE void TextDrawRestore(void);

EWRAM_CODE bool TextIsEnd(void);


#ifdef __cplusplus
}
#endif
#endif
