/*=======================================================================
  xakane for Zaurus
  Copyright 2001, K.Takagi(Kenjo)

  filemgr.c
    A[JCuANZX
=======================================================================*/
/* ================================================================
   ***** Original Code Copyright ******
 
   xakane  --- ONE ` for bright season for X ---
   (c) Copyright 2000, 2001 Nao <nao@sore.totto.to>
   All rights reserved.
================================================================ */

#include <zheaders.h>
#include "wlk1_C_usr.h"
#include "filemgr.h"

static FILE* hFile = 0;
static FATITEM* FileFAT = 0;
static int MaxFile = 0;

/* ----------------------------------------------------------------
	
    t@CI[viJjFAT̓ǂݍ
---------------------------------------------------------------- */
int ArcFile_Init(char* drv)
{
	char file[64];
	int ret = FALSE;

	MaxFile = 0;
	FileFAT = 0;
	sprintf(file, "%s:\\ONE\\WLK1.DAT", drv);
	hFile = fopen(file, "rb");
	if ( hFile ) {
		fseek(hFile, 10, 0);
#ifdef MACAKANE
		MaxFile  =  fgetc(hFile);
		MaxFile |= (fgetc(hFile)<<8);
		MaxFile |= (fgetc(hFile)<<16);
		MaxFile |= (fgetc(hFile)<<24);
#else
		fread((char*)(&MaxFile), 4, 1, hFile);
#endif
		FileFAT = (FATITEM*)NewHeapPtr(MaxFile*sizeof(FATITEM));
		if ( FileFAT ) {
			fread((char*)FileFAT, MaxFile*sizeof(FATITEM), 1, hFile);
			ret = TRUE;
		} else {
			ArcFile_Cleanup();
		}
	}

	return ret;
}


/* ----------------------------------------------------------------
	I
    t@CN[YFAT̔j
---------------------------------------------------------------- */
void ArcFile_Cleanup(void)
{
	if ( FileFAT ) {
		DisposeHeapPtr(FileFAT);
		FileFAT = 0;
	}
	if ( hFile ) {
		fclose(hFile);
		hFile = 0;
	}
	MaxFile = 0;
}


/* ----------------------------------------------------------------
	t@Cǂݍ
	t@CID߁AFATɏ]ăt@Cǂݍ
---------------------------------------------------------------- */
unsigned char* ArcFile_Load(char* file, int* size)
{
	unsigned char* ret = 0;
	char f[16];
	int i;

	if ( !hFile ) return 0;

	// To Upper Case (SZAB doesn't have 'strcasecmp')
	for (i=0; (i<15)&&(file[i]); i++) {
		if ( (file[i]>0x60)&&(file[i]<0x7b) )
			f[i] = file[i]-0x20;
		else
			f[i] = file[i];
	}
	f[i] = 0;

	for (i=0; (sFileList[i])&&(i<MaxFile); i++) {
		if ( !strcmp(f, sFileList[i]) ) {
			*size = FileFAT[i].size;
			ret = (unsigned char*)NewHeapPtr(FileFAT[i].size);
			if ( ret ) {
				fseek(hFile, FileFAT[i].pos, 0);
				fread((char*)ret, FileFAT[i].size, 1, hFile);
			}
		}
	}
	return ret;
}


/* ----------------------------------------------------------------
	t@Cǂݍ
	t@CID߁AFATɏ]ăt@Cǂݍ
---------------------------------------------------------------- */
int ArcFile_GetFileNumber(char* file)
{
	char f[16];
	int i;

	// To Upper Case (SZAB doesn't have 'strcasecmp')
	for (i=0; (i<15)&&(file[i]); i++) {
		if ( (file[i]>0x60)&&(file[i]<0x7b) )
			f[i] = file[i]-0x20;
		else
			f[i] = file[i];
	}
	f[i] = 0;

	for (i=0; (sFileList[i])&&(i<MaxFile); i++) {
		if ( !strcmp(f, sFileList[i]) ) {
			return i;
		}
	}
	return (-1);
}


/* ----------------------------------------------------------------
	ViIt@Cǂݍ
	nt}Ă炵
---------------------------------------------------------------- */
unsigned char* ArcFile_LoadScript(char* file, int* size)
{
	unsigned char *ret, *ptr, *src, bit, *in, *endptr;
	int tree_size, tree_id, left, right, mid;
	ScriptFileHeader* header;
	HuffmanTree *tree, *basetree;
	// t@C̈vt@Cǂݍ
	in = ArcFile_Load(file, size);
	if ( !in ) return 0;

	// WJ̃f[^i[郁m
	header = (ScriptFileHeader*)in;
	basetree = (HuffmanTree *)(header + 1);
	*size = header->expandSize;
	ret = (unsigned char*)NewHeapPtr(*size);
	if ( !ret ) {
		DisposeHeapPtr(in);
		return 0;
	}

	tree_size = (header->rootID & 0xff) + 1 + header->numLeaf;
	src = (unsigned char*)(header + 1 + tree_size);
	bit = 0x80;
	ptr = ret;
	endptr = ret+(*size);

	while (ptr<endptr) {
		tree_id = header->rootID;
		do {
			// 񕪌ID̈v؂T
			left = 0;
			right = tree_size;
			while (left<right) {
				mid = (left + right) / 2;
				if ( basetree[mid].id<tree_id ) {
					left = mid + 1;
				} else {
					right = mid;
				}
			}
			tree = &basetree[left];

			// 1bitǂݍ, ؂֍~Ă
			tree_id = ((*src)&bit)?tree->child1:tree->child0;
			bit >>= 1;
			if ( !bit ) {
				src++;
				bit = 0x80;
				// ǂݍݏI`FbNȂ炱ōsȂ
			}
		} while (tree_id & 0xff00);

		// ݂tree_id̂܂ܕR[hɂȂ
		*ptr++ = tree_id;
	}

	// WJÕf[^폜ċA
	DisposeHeapPtr(in);
	return ret;
}


/* ----------------------------------------------------------------
	wif[^̃[h
	L[ɂÍꂽJPEG炵
---------------------------------------------------------------- */
unsigned char* ArcFile_LoadBG(char* file, int* size)
{
	const char key[] = "YET11.ITaRu.MiKiPoN.ShiNoRi-";		// L[
	int i, j, num, l = strlen(key);
	unsigned char *ret, *ptr;

	// t@C̈vt@Cǂݍ
	ret = ArcFile_Load(file, size);
	if ( !ret ) return 0;
	num = (*size)>>12;		// size/0x1000;

	ptr = ret;
	for (i=0; i<num; i++) {
		for (j=0; j<0x1000; j++) {
			*ptr ^= key[j%l];
			ptr++;
		}
	}
	// c
	for (j=0; j<((*size)&0xfff); j++) {
		*ptr ^= key[j%l];
		ptr++;
	}

	return ret;
}


/* ----------------------------------------------------------------
	LN^f[^Ƃ̃[h
	BMP̃OXk炵
---------------------------------------------------------------- */
unsigned char* ArcFile_LoadBMP(char* file, int* size)
{
	int i, j, orgsize = 0;
	unsigned char *ret, *ptr, *in, *out, *endptr;

	// t@C̈vt@Cǂݍ
	in = ArcFile_Load(file, size);
	if ( !in ) return 0;

	endptr = in+(*size);

	// kÕt@CTCYvZ
	for (ptr=in; ptr<endptr; ptr++) {
		if ( *ptr==0xf0 ) {
			ptr++;
			orgsize += *ptr;
			if ( *ptr>2 ) ptr++;
		} else {
			orgsize++;
		}
	}

	// WJpobt@擾
	ret = NewHeapPtr(orgsize);
	if ( !ret ) {
		DisposeHeapPtr(in);
		return 0;
	}

	// WJ
	for (ptr=in, out=ret; ptr<endptr; ptr++) {
		if ( *ptr!=0xf0 ) {
			*out++ = *ptr;
		} else {
			ptr++;
			i = *ptr;
			if ( i>2 ) {
				ptr++;
				for (j=0; j<i; j++) {
					*out++ = *ptr;
				}
			} else if ( i==2 ) {
				*out++ = 0xf0;
				*out++ = 0xf0;
			} else {
				*out++ = 0xf0;
			}
		}
	}

	DisposeHeapPtr(in);
	*size = orgsize;

	return ret;
}
