/*=======================================================================
  xakane for Zaurus
  Copyright 2001, K.Takagi(Kenjo)
=======================================================================*/
/* ================================================================
   ***** Original Code Copyright ******
 
   xakane  --- ONE ` for bright season for X ---
   (c) Copyright 2000, 2001 Nao <nao@sore.totto.to>
   All rights reserved.
================================================================ */

#include <zheaders.h>
#include "filemgr.h"
#include "system.h"
#include "scenario.h"

static unsigned short curpos = 0;
static char curseen[16];
static unsigned char* base = 0;

// -----------------------------------------------------------------------------------------
//   ėp[`
// -----------------------------------------------------------------------------------------
static short ReadShort(void)
{
	unsigned short ret;
	ret  = base[curpos++];
	ret |= base[curpos++]<<8;
	return ((short)ret);
}

static int ReadInt(void)
{
	unsigned int ret;
	ret  = base[curpos++];
	ret |= base[curpos++]<<8;
	ret |= base[curpos++]<<16;
	ret |= base[curpos++]<<24;
	return ((int)ret);
}

static void SkipText(void)
{
	while ( base[curpos++] ) {}
}


// -----------------------------------------------------------------------------------------
//   R}hƂ̏
// -----------------------------------------------------------------------------------------
// _~[R}hiG[j
static int Scn_Dm(void)
{
	char str[256];
	sprintf(str, "Unknown Cmd : $%02X @ %s/$%04X", base[curpos-1], curseen, curpos-1);
	Error(str);
	return TRUE;
}

// JE^Zbg
static int Scn_00(void)
{
	int   idx = ReadShort();
	short val = ReadShort();
	Sys_SetFlag(FLAG_COUNT, idx, val);
	Sys_ChangePos(curpos);
	return TRUE;
}

// tOZbg
static int Scn_04(void)
{
	int   idx = ReadShort();
	short val = ReadShort();
	Sys_SetFlag(FLAG_SWITCH, idx, val);
	Sys_ChangePos(curpos);
	return TRUE;
}

// JE^Z
static int Scn_08(void)
{
	int   idx = ReadShort();
	short val = ReadShort();
	Sys_SetFlag(FLAG_COUNT, idx, Sys_GetFlag(FLAG_COUNT, idx)+val);
	Sys_ChangePos(curpos);
	return TRUE;
}

// JE^Z
static int Scn_0c(void)
{
	int   idx = ReadShort();
	short val = ReadShort();
	Sys_SetFlag(FLAG_COUNT, idx, Sys_GetFlag(FLAG_COUNT, idx)-val);
	Sys_ChangePos(curpos);
	return TRUE;
}

// Wv
static int Scn_10(void)
{
	curpos = ReadShort();
	return TRUE;
}

// 
static int Scn_11(void)
{
	short val, arg[16], n = 0;
	unsigned char c = 0;

	while (1) {
		c = base[curpos++];
		switch (c) {
			case 0x00:
				val = ReadShort();
				if ( !arg[0] ) curpos = val;	// sɃWv
				return TRUE;
			case 0x02:
				n--;
				if ( arg[n-1]==arg[n] ) arg[n-1] = 1; else arg[n-1] = 0;
				break;
			case 0x03:
				n--;
				if ( arg[n-1]<arg[n] ) arg[n-1] = 1; else arg[n-1] = 0;
				break;
			case 0x04:
				n--;
				if ( arg[n-1]>arg[n] ) arg[n-1] = 1; else arg[n-1] = 0;
				break;
			case 0x05:
				n--;
				if ( arg[n-1]<=arg[n] ) arg[n-1] = 1; else arg[n-1] = 0;
				break;
			case 0x06:
				n--;
				if ( arg[n-1]>=arg[n] ) arg[n-1] = 1; else arg[n-1] = 0;
				break;
			case 0x0a:
				n--;
				if ( arg[n-1]||arg[n] ) arg[n-1] = 1; else arg[n-1] = 0;
				break;
			case 0x0f:
				n--;
				if ( arg[n-1]&&arg[n] ) arg[n-1] = 1; else arg[n-1] = 0;
				break;
			case 0x15:
				val = ReadShort();
				arg[n++] = val;
				break;
			case 0x16:
				val = ReadShort();
				arg[n++] = Sys_GetFlag(FLAG_COUNT, val);
				break;
			case 0x17:
				val = ReadShort();
				arg[n++] = Sys_GetFlag(FLAG_SWITCH, val);
				break;
			default:
				Error("Cond : Unknown cmd");
				break;
		}
	}
}

// bZ[W
static int Scn_15(void)
{
	unsigned char subcmd = base[curpos++];
	Sys_StartMessage((char*)(base+curpos), curpos-2);
	SkipText();
	return TRUE;
}

// I
static int Scn_17(void)
{
	short idx = ReadShort();		// ʂԂtOԍ
	while ( base[curpos] ) {		// ACeǉ
		Sys_AddSelect((char*)(base+curpos));
		SkipText();
	}
	curpos++;
	Sys_StartSelect(idx);			// IJn
	return TRUE;					// iSYS_STATE_SELECT甲iKŁAwϐɌʂԂĂj
}

// XNvgւ̃Wv
static int Scn_18(void)
{
	int size;
	unsigned char* newbase;

	newbase = Sys_LoadScript((char*)(base+curpos), &size);
	if ( newbase ) {
		strncpy(curseen, (char*)(base+curpos), 16);
		DisposeHeapPtr(base);
		base = newbase;
	} else {
		Error("Error : Fail to load script");
	}
	curpos = 0;
	Sys_ChangeSeen(curseen);
	Sys_ChangePos(0);
	return TRUE;
}

// XNvgւ̃R[
static int Scn_19(void)
{
	int size;
	unsigned char *newbase, *name = base+curpos;

	newbase = Sys_LoadScript((char*)name, &size);
	SkipText();
	Sys_PushStack(&curpos, curseen);
	if ( newbase ) {
		strncpy(curseen, (char*)name, 16);
		DisposeHeapPtr(base);
		base = newbase;
	} else {
		Error("Error : Fail to load script");
		Sys_PopStack(&curpos, curseen);
	}
	curpos = 0;
	Sys_ChangeSeen(curseen);
	Sys_ChangePos(curpos);
	return TRUE;
}

// XNvgփ^[
static int Scn_1a(void)
{
	int size;
	unsigned char *newbase;

	Sys_PopStack(&curpos, curseen);
	newbase = Sys_LoadScript(curseen, &size);
	if ( newbase ) {
		DisposeHeapPtr(base);
		base = newbase;
	} else {
		Error("Error : Fail to load script");
	}
	Sys_ChangeSeen(curseen);
	Sys_ChangePos(curpos);
	return TRUE;
}

// wiǂݍ݁iXN[j
static int Scn_28(void)
{
	Sys_SetBG((char*)(base+curpos));
	SkipText();
	Sys_SetChr("\0", 0, 0);
	Sys_SetChr("\0", 1, 0);
	Sys_DrawScreen();
	Sys_StartEffect(EF_SCROLL);
	Sys_ChangePos(curpos);
	return TRUE;
}

// EFCgiZj
static int Scn_64(void)
{
	int t = (base[curpos++]*1.52);
	Sys_StartWait(t);
	return TRUE;
}

// L[҂
static int Scn_65(void)
{
	Sys_StartKeyWait();
	return TRUE;
}

// wiǂݍ݁iGtFNgj
static int Scn_66(void)
{
	int idx = base[curpos++];
	Sys_SetBG((char*)(base+curpos));
	SkipText();
	Sys_SetChr("\0", 0, 0);
	Sys_SetChr("\0", 1, 0);
	Sys_DrawScreen();
	Sys_StartEffect(idx);
	Sys_ChangePos(curpos);
	return TRUE;
}

// ubNAEgiGtFNgj
static int Scn_67(void)
{
	int idx = base[curpos++];
	Sys_SetBG("\0");
	Sys_SetChr("\0", 0, 0);
	Sys_SetChr("\0", 1, 0);
	Sys_DrawScreen();
	Sys_StartEffect(idx);
	Sys_ChangePos(curpos);
	return TRUE;
}

// ubNAEgiXN[j
static int Scn_69(void)
{
	Sys_SetBG("\0");
	Sys_SetChr("\0", 0, 0);
	Sys_SetChr("\0", 1, 0);
	Sys_DrawScreen();
	Sys_StartEffect(EF_SCROLL);
	Sys_ChangePos(curpos);
	return TRUE;
}

// L\
static int Scn_6a(void)
{
	unsigned char num = base[curpos++];
	unsigned char pos = base[curpos++];
	Sys_SetChr((char*)(base+curpos), num, pos);
	SkipText();
	Sys_DrawScreen();
	Sys_StartEffect(EF_FADE);
	Sys_ChangePos(curpos);
	return TRUE;
}

// LύX
static int Scn_6b(void)
{
	unsigned char num = base[curpos++];
	unsigned char pos = base[curpos++];
	Sys_SetChr((char*)(base+curpos), num, pos);
	SkipText();
	Sys_DrawScreen();
	Sys_StartEffect(EF_FADE);
	Sys_ChangePos(curpos);
	return TRUE;
}

// L
static int Scn_6c(void)
{
	unsigned char num = base[curpos++];
	if ( num>1 ) {
		Sys_SetChr("\0", 0, 0);
		Sys_SetChr("\0", 1, 0);
	} else {
		Sys_SetChr("\0", num, 0);
	}
	Sys_DrawScreen();
	Sys_StartEffect(EF_FADE);
	Sys_ChangePos(curpos);
	return TRUE;
}

// BGMĐ
static int Scn_6d(void)
{
	unsigned char trk  = base[curpos++];
	unsigned char loop = base[curpos++];
	Sys_StartBGM(trk, loop);
	Sys_ChangePos(curpos);
	return TRUE;
}

// BGM~
static int Scn_6e(void)
{
	unsigned char fade = base[curpos++];
	Sys_StopBGM(fade);
	Sys_ChangePos(curpos);
	return TRUE;
}

// t\
static int Scn_71(void)
{
	// Cnt[0]:ACnt[1]:ACnt[2]:ACnt[3]:
	// EɃtF[hC\Ab\tF[hAEg
	Sys_StartDateWindow();
	return TRUE;
}

// O
static int Scn_72(void)
{
	unsigned char idx = base[curpos++];
	Sys_SetFlag(FLAG_COUNT, idx, 0);
	return TRUE;
}

// WaitXLbvL薳̕ύX
static int Scn_74(void)
{
	Sys_SetWaitSkip(base[curpos++]);
	return TRUE;
}

// H
static int Scn_75(void)
{
	short idx = base[curpos++];
	return TRUE;
}

// EFCgij
static int Scn_76(void)
{
	int t = (base[curpos++]*100);
	Sys_StartWait(t);
	return TRUE;
}

// VXetOZbg
static int Scn_77(void)
{
	int   idx = base[curpos++];
	short val = base[curpos++];
	Sys_SetFlag(FLAG_SYSTEM, idx, val);
	Sys_ChangePos(curpos);
	return TRUE;
}

// VXetO擾iJE^tOɓj
static int Scn_78(void)
{
	int idxs = base[curpos++];
	int idxc = base[curpos++];
	Sys_SetFlag(FLAG_COUNT, idxc, Sys_GetFlag(FLAG_SYSTEM, idxs));
	Sys_ChangePos(curpos);
	return TRUE;
}

// u^Cgɖ߂vp̃|C^ݒ
static int Scn_79(void)
{
	return TRUE;
}

// ^Cgj[I
static int Scn_7a(void)
{
	short idx = base[curpos++];
	Sys_StartTitleMenu(idx);
	return TRUE;
}

// H
static int Scn_7b(void)
{
	return TRUE;
}

// [hX^[g̃t@CI
static int Scn_7c(void)
{
Error("Load File Select");
	return TRUE;
}

// Special̃j[I
static int Scn_7e(void)
{
	short idx = base[curpos++];
	Sys_StartAppendixMenu(idx);
	return TRUE;
}

// j[iIj
static int Scn_7f(void)
{
	Sys_Terminate();
	return TRUE;
}

// CG[hł̃LI
static int Scn_80(void)
{
	short idx = base[curpos++];
	Sys_StartCGCharMenu(idx);
	return TRUE;
}

// CG[hł̃OtBbNI
static int Scn_81(void)
{
	short idx = base[curpos++];
	Sys_StartCGSelMenu(idx);
	return TRUE;
}

// BGM[hł̋ȑI
static int Scn_82(void)
{
	short idx = base[curpos++];
	Sys_StartBGMMenu(idx);
	return TRUE;
}

// J_[\
static int Scn_84(void)
{
	Sys_StartCalender();
	return TRUE;
}

// XNvg̏I
static int Scn_ff(void)
{
	return TRUE;
}

// -----------------------------------------------------------------------------------------
//   fR[_{̂ւ̃e[u
// -----------------------------------------------------------------------------------------
static int (*Scn_Decode[256])(void) = {
	&Scn_00, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_04, &Scn_Dm, &Scn_Dm, &Scn_Dm,		// 00
	&Scn_08, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_0c, &Scn_Dm, &Scn_Dm, &Scn_Dm,
	&Scn_10, &Scn_11, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_15, &Scn_Dm, &Scn_17,		// 10
	&Scn_18, &Scn_19, &Scn_1a, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,		// 20
	&Scn_28, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,		// 30
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,		// 40
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,		// 50
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_64, &Scn_65, &Scn_66, &Scn_67,		// 60
	&Scn_Dm, &Scn_69, &Scn_6a, &Scn_6b, &Scn_6c, &Scn_6d, &Scn_6e, &Scn_Dm,
	&Scn_Dm, &Scn_71, &Scn_72, &Scn_Dm, &Scn_74, &Scn_75, &Scn_76, &Scn_77,		// 70
	&Scn_78, &Scn_79, &Scn_7a, &Scn_7b, &Scn_7c, &Scn_Dm, &Scn_7e, &Scn_7f,
	&Scn_80, &Scn_81, &Scn_82, &Scn_Dm, &Scn_84, &Scn_Dm, &Scn_Dm, &Scn_Dm,		// 80
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,		// 90
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,		// A0
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,		// B0
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,		// C0
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,		// D0
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,		// E0
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm,		// F0
	&Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_Dm, &Scn_ff
};


// -----------------------------------------------------------------------------------------
//   
// -----------------------------------------------------------------------------------------
int Scn_Init(void)
{
	int size, ret = TRUE;

	curpos = 0;
	sprintf(curseen, "INIT");
//sprintf(curseen, "NV30");
	base = Sys_LoadScript(curseen, &size);
	if ( !base ) {
		ret = FALSE;
		Error("Error : Fail to load script");
	}
	return ret;
}


// -----------------------------------------------------------------------------------------
//   I
// -----------------------------------------------------------------------------------------
void Scn_Cleanup(void)
{
	if ( base ) DisposeHeapPtr(base);
	base = 0;
}


// -----------------------------------------------------------------------------------------
//   Zbgi[hpj
// -----------------------------------------------------------------------------------------
void Scn_Reset(unsigned short p, char* s)
{
	int size;

	curpos = p;
	sprintf(curseen, s);
	base = Sys_LoadScript(curseen, &size);
	if ( !base ) {
		Error("Error : Fail to load script");
	}
}


// -----------------------------------------------------------------------------------------
//   ^Cg֖߂
// -----------------------------------------------------------------------------------------
void Scn_Title(void)
{
	int size;

	curpos = 0;
	sprintf(curseen, "INIT");
	base = Sys_LoadScript(curseen, &size);
	if ( !base ) {
		Error("Error : Fail to load script");
	} else {
		// XNvgςĂꍇziƂ͎vPhj
		if ( base[0x14]==0x79 ) {
			curpos = 0x14;
		}
	}
}


// -----------------------------------------------------------------------------------------
//   s
// -----------------------------------------------------------------------------------------
void Scn_Run(void)
{
	unsigned char cmd;
	int endflag = FALSE;

	do {
		if ( Sys_InEffect() ) {				// WaitEffectsȂViI͂߂Ȃ
			endflag = TRUE;
		} else {
			Sys_ChangePos(curpos);
			cmd = base[curpos++];
/*{
char mes[256];
sprintf(mes, "Seen:%s Pos:$%04X Cmd:$%02X", curseen, curpos-1, cmd);
Error(mes);
}*/
			endflag = Scn_Decode[cmd]();
		}
	} while ( !endflag );
}

