/*=======================================================================
  xakane for Zaurus
  Copyright 2001, K.Takagi(Kenjo)
=======================================================================*/
/* ================================================================
   ***** Original Code Copyright ******
 
   xakane  --- ONE ` for bright season for X ---
   (c) Copyright 2000, 2001 Nao <nao@sore.totto.to>
   All rights reserved.
================================================================ */

#include <zheaders.h>
#include "wlk1_C_usr.h"
#include "filemgr.h"
#include "system.h"

#define MAX_STACK 8

// WinłƂꂭ炢BƖ邷H
#if 0
#define WINR	156
#define WING	154
#define WINB	198
#else
// ꂭ炢ɂƂ܂傤
#define WINR	128
#define WING	126
#define WINB	168
#endif

#define MAXLOG 100

// bZ[WEBhËʒuƃTCY
#define WINX 38
#define WINY 338
#define WINW 564
#define WINH 132

WINDOWHD	hMainWnd = 0;
WINDOWHD	hBackScr = 0;
WINDOWHD	hHideScr = 0;
WINDOWHD	hJpegScr = 0;
WINDOWHD	hOmakeScr = 0;
WINDOWHD	hScr[2] = {0, 0};
static unsigned char* ItemBitmap = 0;
static unsigned int WaitBase;
static unsigned int AnmWaitBase;
static int	AnmCount = 0;
static int	PrimScr = 0;
static int	CurEffect = 0;
static int	CurEfStep = 0;
static int	CurWait = 0;
static int	MesX = 0, MesY = 0;
static int	MesIndent = 0;
static unsigned int DateBase;
static char*	MsgPtr;
static short	SelResult;
static short	SelItem;
static short	SelMaxItem = 0;
static short	MouseX = 0, MouseY = 0;
static char	MesWinFlag = 0;
static char	SysState = SYS_STATE_NONE;
static char	MouseButtonFlag = 0;
static char	SkippingFlag = 0;
static char	KeyCode = 0;
static char	MessageBuffer[256];
static char	LogBuffer[MAXLOG][256];
static char	SelItemStr[4][64];
static char	DateState;
static char	SaveFile[64];
static char	JpegItemLoaded = 0;
static char	BGMModeFlag = 0;
char		VGAFlag = 0;
char		TerminateFlag = 0;
char		LogStart = 0;
char		LogEnd = 0;
char		CurLogPage = 0;

typedef struct {
	short sm;
	short sd;
	short sh;
	short sn;
	short m;
	short d;
	short h;
	short n;
	short w;
} STRUCT_SAVEINFO;

typedef struct {
	short SystemFlag[256];
	short ResumeFlag;
	short LastSaveLoad;
	STRUCT_SAVEINFO si[MAXSAVEFILE+1];
	short CfgSkipMode;
	short CfgEffectMode;
	short CfgFontMode;
	short CfgBGMVolume;
	short reserved1;
	short reserved2;
	short reserved3;
	short reserved4;
	unsigned char ReadFlag[79][180];
} STRUCT_SYSDATA;

typedef struct {
	short savemonth;
	short saveday;
	short savehour;
	short savemin;
	short flag[2][256];
	short stacknum;
	short curbgm;
	short curbgmloop;
	unsigned short curpos;
	char curseen[16];
	unsigned short stackpos[MAX_STACK];
	char stackseen[MAX_STACK][16];
	char waitskipflag;
	char curbg[16];
	char curchr[2][16];
	char curchrpos[2];
	char firstname[10];		// Sp4
	char lastname[10];		// Sp4
} STRUCT_SAVEDATA;

static STRUCT_SYSDATA  sysdata;
static STRUCT_SAVEDATA savedata;
unsigned short  readflag[180*8];
short           maxreadflag;
short           scriptnum;
static unsigned short  curreadflag;

// -----------------------------------------------------------------------------------------
//   ėp̃_CAO֘A[`
// -----------------------------------------------------------------------------------------
void Error(char* mes)
{
	MESSAGE	msg;

	msg.CommonMsg.MessageID = AlboxToolID;
	AlertExecStr( &msg, (unsigned char*)mes, ALB_CENTER, KAKUNIN_BTN );
}


int YesNo(char* mes)
{
	MESSAGE	msg;

	msg.CommonMsg.MessageID = AlboxToolID;
	AlertExecStr( &msg, (unsigned char*)mes, ALB_CENTER, YES_NO_BTN );

	if ( msg.AlboxFinish.TargetID == DefBtnYesID )
		return TRUE;
	else
		return FALSE;
}


// -----------------------------------------------------------------------------------------
//   RXgN^^fXgN^ɂ镔
// -----------------------------------------------------------------------------------------
void Sys_Reset(void)
{
	CurEffect = 0;
	CurWait = 0;
	MesWinFlag = 0;
	MesX = 0;
	MesY = 0;
	SysState = SYS_STATE_NONE;
	MsgPtr = MessageBuffer;
	SelMaxItem = 0;
	MouseX = 0;
	MouseY = 0;
	MouseButtonFlag = 0;
	KeyCode = 0;
	DateState = 0;
	BGMModeFlag = 0;
}


int Sys_Init(void)
{
	int ret = TRUE;
	RECTANGLE rect;

	Sys_Reset();

	TerminateFlag = 0;
	hBackScr = 0;
	hHideScr = 0;
	hJpegScr = 0;
	hScr[0] = 0;
	hScr[1] = 0;
	PrimScr = 0;
	ItemBitmap = 0;
	JpegItemLoaded = 0;
	BGMModeFlag = 0;

	LogStart = 0;
	LogEnd = 0;

	// Z[uf[^l
	memset((char*)(&sysdata), 0, sizeof(sysdata));
	memset((char*)(&savedata), 0, sizeof(savedata));
	strcpy(savedata.firstname, "_");
	strcpy(savedata.lastname, "܌");
	strcpy(savedata.curseen, "INIT");
	savedata.curpos = 0;
	savedata.waitskipflag = 1;

	// XN[obt@1&2
	rect.left = rect.top = 0;
	rect.width = 640;
	rect.height = 480;
	hScr[0] = NewOffscreen(&rect, 16, 2);
	hScr[1] = NewOffscreen(&rect, 16, 2);
	if ( (!hScr[0])||(!hScr[1]) ) {
		ret = FALSE;
	} else {
		memset((char*)GetPixMapAdrOffscreen(hScr[0]), 0, 640*480*2);
		memset((char*)GetPixMapAdrOffscreen(hScr[1]), 0, 640*480*2);
	}

	// JPEGWJXN[obt@iBGۑpj
	hJpegScr = NewOffscreen(&rect, 16, 2);
	if ( !hJpegScr )
		ret = FALSE;
	else
		memset((char*)GetPixMapAdrOffscreen(hJpegScr), 0, 640*480*2);

	// \XN[obNobt@iQVGÂ݁Bkpj
	if ( !VGAFlag ) {
		rect.width = 320;
		rect.height = 240;
		hBackScr = NewOffscreen(&rect, 16, 2);
		if ( !hBackScr )
			ret = FALSE;
		else
			memset((char*)GetPixMapAdrOffscreen(hBackScr), 0, 320*240*2);
		hHideScr = NewOffscreen(&rect, 16, 2);
		if ( !hHideScr )
			ret = FALSE;
	}

	rect.width = 1152;
	rect.height = 620;
	hOmakeScr = NewOffscreen(&rect, 16, 2);
	if ( !hOmakeScr )
		ret = FALSE;
	else
		memset((char*)GetPixMapAdrOffscreen(hOmakeScr), 0, 1152*620*2);
	return ret;
}


void Sys_Cleanup()
{
	Sys_SaveSystemFlags();

	if ( ItemBitmap ) DisposeHeapPtr(ItemBitmap);
	if ( hOmakeScr ) DisposeOffscreen(hOmakeScr);
	if ( hHideScr )	DisposeOffscreen(hHideScr);
	if ( hBackScr )	DisposeOffscreen(hBackScr);
	if ( hJpegScr )	DisposeOffscreen(hJpegScr);
	if ( hScr[0] )	DisposeOffscreen(hScr[0]);
	if ( hScr[1] )	DisposeOffscreen(hScr[1]);

	ItemBitmap = 0;
	hOmakeScr = 0;
	hHideScr = 0;
	hBackScr = 0;
	hJpegScr = 0;
	hScr[0] = 0;
	hScr[1] = 0;
}


void Sys_Terminate(void)
{
	TerminateFlag = 1;
}


// -----------------------------------------------------------------------------------------
//   ^C}֘A
// -----------------------------------------------------------------------------------------
unsigned int Sys_GetCurrentTimer(void)
{
	return (GetFastTickCount()*10);
}


// -----------------------------------------------------------------------------------------
//   \ʂ̃Abvf[g
//     VGA/QVGA𔻕ʂďς邱
// -----------------------------------------------------------------------------------------
void Sys_Update(int x1, int y1, int x2, int y2)
{
	COLOR		dmy;		/* EBhENAF */
	RECTANGLE	rect;		/* `͈͎wp */
	unsigned short *srcbuf, *dstbuf, *src, *dst;

	if ( (!hScr[0])||(!hScr[1]) ) return;
	if ( VGAFlag ) {
		// VGAB݂̕\ʂ̂܂ܓ]
		rect.left = (x1<<2);
		rect.top = (y1<<2);
		rect.width = ((x2-x1+1)<<2)-1;
		rect.height = ((y2-y1+1)<<2)-1;
		DrawOffscreen(hMainWnd, &rect, hScr[PrimScr], &rect, 0, NULL, &dmy, &dmy);
	} else {
		// QVGAB݂̕\ʂBackScrɏk]APixMapɓ]
		int x, y, w, h;

		x1 &= 0xfffe;
		y1 &= 0xfffe;
		x2 |= 1;
		y2 |= 1;
		w = (x2-x1+1);
		h = (y2-y1+1);
		if ( (x1+w)>640 ) w = 640-x1;
		if ( (y1+h)>480 ) h = 480-y1;
		w >>= 1;
		h >>= 1;
		srcbuf = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr]);
		dstbuf = (unsigned short*)GetPixMapAdrOffscreen(hBackScr);
		srcbuf += y1*640+x1;
		dstbuf += (y1>>1)*320+(x1>>1);
		for (y=0; y<h; y++) {
			src = srcbuf;
			dst = dstbuf;
			for (x=0; x<w; x++) {
				// 4Pixel̕ς1Pixel̃f[^B
				// 2Pixel̕ς2āAXɂ2𕽋ςĂB
				// 덷oPhA܂i
				int register s0, s1, s2;
				s1 = src[0];
				s2 = src[1];
				s0 = (s1&s2)+(((s1^s2)&0xf7de)>>1);
				s1 = src[640];
				s2 = src[641];
				s1 = (s1&s2)+(((s1^s2)&0xf7de)>>1);
				*dst = (s0&s1)+(((s0^s1)&0xf7de)>>1);
				src += 2;
				dst++;
			}
			srcbuf += 1280;
			dstbuf += 320;
		}
		rect.left = (x1<<1);
		rect.top = (y1<<1);
		rect.width = (w<<2)-1;
		rect.height = (h<<2)-1;

		DrawOffscreen(hMainWnd, &rect, hBackScr, &rect, 0, NULL, &dmy, &dmy);
	}
}


void Sys_Update2(int x1, int y1, int x2, int y2)
{
	COLOR		dmy;		/* EBhENAF */
	RECTANGLE	rect;		/* `͈͎wp */

	if ( !VGAFlag ) {
		// QVGÂ
		int w, h;

		x1 &= 0xfffe;
		y1 &= 0xfffe;
		x2 |= 1;
		y2 |= 1;
		w = (x2-x1+1);
		h = (y2-y1+1);
		if ( (x1+w)>640 ) w = 640-x1;
		if ( (y1+h)>480 ) h = 480-y1;
		w >>= 1;
		h >>= 1;
		rect.left = (x1<<1);
		rect.top = (y1<<1);
		rect.width = (w<<2)-1;
		rect.height = (h<<2)-1;

		DrawOffscreen(hMainWnd, &rect, hBackScr, &rect, 0, NULL, &dmy, &dmy);
	}
}


void Sys_Redraw(void)
{
	COLOR		dmy;		/* EBhENAF */
	RECTANGLE	rect;		/* `͈͎wp */

	if ( VGAFlag ) {
		rect.left = 0;
		rect.top = 0;
		rect.width = (640<<2)-1;
		rect.height = (480<<2)-1;
		DrawOffscreen(hMainWnd, &rect, hScr[PrimScr], &rect, 0, NULL, &dmy, &dmy);
	} else {
		rect.left = 0;
		rect.top = 0;
		rect.width = (320<<2)-1;
		rect.height = (240<<2)-1;
		DrawOffscreen(hMainWnd, &rect, hBackScr, &rect, 0, NULL, &dmy, &dmy);
	}
}


void Sys_DrawScreen(void)
{
	int i;
	unsigned int t;

	if ( savedata.curbg[0] ) {
		Sys_LoadBG();
	} else {
		Sys_ClearBG();
	}

	for (i=0; i<2; i++) {
		if ( savedata.curchr[i][0] ) {
			Sys_LoadChr(savedata.curchr[i], savedata.curchrpos[i]);
		}
	}

/*
	if ( DateState ) {
		i = DateState;
		t = DateBase;
		Sys_StartDateWindow();
		DateState = i;
		DateBase = t;
	}
*/

	MesWinFlag = 0;		// ĕ`悵Window͏
}


static void Sys_ExchangePixel(int sx, int sy, int w, int h, int dx, int dy)
{
	unsigned short *srcbuf, *dstbuf, *src, *dst, s;
	int x, y;

	srcbuf = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr]);
	dstbuf = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^1]);
	srcbuf += sy*640+sx;
	dstbuf += dy*640+dx;

	for (y=0; y<h; y++) {
		src = srcbuf;
		dst = dstbuf;
		for (x=0; x<w; x++) {
			s = *dst;
			*dst = *src;
			*src = s;
			src++;
			dst++;
		}
		srcbuf += 640;
		dstbuf += 640;
	}
}


static void Sys_BltPixel(int sx, int sy, int w, int h, int dx, int dy)
{
	unsigned short *srcbuf, *dstbuf, *src, *dst;
	int x, y;

	srcbuf = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^1]);
	dstbuf = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr]);
	srcbuf += sy*640+sx;
	dstbuf += dy*640+dx;

	for (y=0; y<h; y++) {
		src = srcbuf;
		dst = dstbuf;
		for (x=0; x<w; x++) {
			*dst++ = *src++;
		}
		srcbuf += 640;
		dstbuf += 640;
	}
}


// -----------------------------------------------------------------------------------------
//   wiǂݍ݃[`
//     vJPG̓WJ
// -----------------------------------------------------------------------------------------
void Sys_LoadBG(void)
{
// ǂނƂ܂ɒx̂ŁAUobNobt@ɓǂłiSetBGsV[ύXj
// \͂玝Ă
/*
	unsigned char* buf;
	unsigned short w, h;
	int size;
	DRFFILE drf;
	RECTANGLE srect, drect;

	buf = ArcFile_LoadBG(file, &size);
	if ( buf ) {
		drf.Mode = RamMode;
		drf.FError = 0;
		drf.Drf.RamFileStr.HeapHandle = &buf;
		drf.Drf.RamFileStr.Size = size;
		drf.Drf.RamFileStr.Offset = 0;
		JpegGetSize(&drf, &w, &h);
		srect.top = srect.left = 0;
		srect.width = w;
		srect.height = h;
		drect.left = x;
		drect.top = y;
		drect.width = w;
		drect.height = h;
		JpegDecode(&drf, &srect, hScr[PrimScr^1], &drect, true);
		DisposeHeapPtr(buf);
	}
*/
	unsigned short *src, *dst;

	src = (unsigned short*)GetPixMapAdrOffscreen(hJpegScr);
	dst = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^1]);
	memcpy(dst, src, 640*480*2);
}


void Sys_SetBG(char* file)
{
	unsigned char* buf;
	unsigned short w, h;
	int size, i;
	DRFFILE drf;
	RECTANGLE srect, drect;

	if ( file[0] ) {
		if ( strcmp(file, savedata.curbg) ) {
			DateState = 0;
			Sys_HideWindow();
			Sys_Update(WINX, WINY, WINX+WINW-1, WINY+WINH-1);
			strncpy(savedata.curbg, file, 16);
			buf = ArcFile_LoadBG(file, &size);
			if ( buf ) {
				drf.Mode = RamMode;
				drf.FError = 0;
				drf.Drf.RamFileStr.HeapHandle = &buf;
				drf.Drf.RamFileStr.Size = size;
				drf.Drf.RamFileStr.Offset = 0;
				JpegGetSize(&drf, &w, &h);
				srect.left = 0;
				srect.top = 0;
				srect.width = w;
				srect.height = h;
				if ( w>640 ) w = 640;
				if ( h>480 ) h = 480;
				drect.left = 0;
				drect.top = 0;
				drect.width = w;
				drect.height = h;
				// ubLOœWJ
				// xˁiBmubLO[ĥcc
				JpegDecode(&drf, &srect, hJpegScr, &drect, true);
				DisposeHeapPtr(buf);
			}
			i = (ArcFile_GetFileNumber(file)-134);
			if ( (i>=0)&&(i<126) ) Sys_SetFlag(FLAG_SYSTEM, i, 1);
		}
	} else {
		if ( savedata.curbg[0] ) {
			DateState = 0;
			Sys_HideWindow();
			Sys_Update(WINX, WINY, WINX+WINW-1, WINY+WINH-1);
			memset(savedata.curbg, 0, 16);
		}
	}
}


// -----------------------------------------------------------------------------------------
//   Sys_PutJpegItem
//     ܂[hp
// -----------------------------------------------------------------------------------------
void Sys_LoadJpegItem(void)
{
	unsigned char* buf;
	int size, i;
	unsigned short w, h;
	DRFFILE drf;
	RECTANGLE srect, drect;

	if ( JpegItemLoaded ) return;

	buf = ArcFile_LoadBG("ETC07", &size);
	if ( buf ) {
		drf.Mode = RamMode;
		drf.FError = 0;
		drf.Drf.RamFileStr.HeapHandle = &buf;
		drf.Drf.RamFileStr.Size = size;
		drf.Drf.RamFileStr.Offset = 0;
		JpegGetSize(&drf, &w, &h);
		srect.left = 0;
		srect.top = 0;
		srect.width = w;
		srect.height = h;
		drect.left = 0;
		drect.top = 0;
		drect.width = w;
		drect.height = h;
		JpegDecode(&drf, &srect, hOmakeScr, &drect, true);
		DisposeHeapPtr(buf);
		JpegItemLoaded = 1;
	}
}


void Sys_PutJpegItem(int sx, int sy, int w, int h, int dx, int dy, int scr)
{
	unsigned short *src, *srcbuf, *dst, *dstbuf, *tmp;
	int x, y, size;

	srcbuf = (unsigned short*)GetPixMapAdrOffscreen(hOmakeScr);
	dstbuf = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^scr]);
	srcbuf += 1152*sy+sx;
	dstbuf += 640*dy+dx;
	for (y=0; y<h; y++) {
		src = srcbuf;
		dst = dstbuf;
		for (x=0; x<w; x++) {
			*dst++ = *src++;
		}
		srcbuf += 1152;
		dstbuf += 640;
	}
}


// -----------------------------------------------------------------------------------------
//   wiNA[`
//     tF[hAEgp
// -----------------------------------------------------------------------------------------
void Sys_ClearBG(void)
{
	unsigned char* buf;
	buf = (unsigned char*)GetPixMapAdrOffscreen(hScr[PrimScr^1]);
	memset(buf, 0, 640*480*2);
	memset(savedata.curbg, 0, 16);
}


// -----------------------------------------------------------------------------------------
//   Lǂݍ
//     256FBMP̕\[`Bėp͎ȂB
// -----------------------------------------------------------------------------------------
void Sys_LoadChr(char* file, int pos)
{
	unsigned char *buf, *src;
	unsigned short *dst;
	int x, y, pad, size, width, height, dx, i, w, h;
	unsigned int c, pal[256];

	buf = ArcFile_LoadBMP(file, &size);
	if ( buf ) {
		// SZABł̍\̂DWORD Align_݂cIvVǂɂ̂Ȃ
		for (i=0; i<1024; i+=4) {
			// LongŃANZX̂ňU[J
			// łɂ16bitϊƂ
			c  = buf[i+54]|(buf[i+55]<<8)|(buf[i+56]<<16)|(buf[i+57]<<24);
			if ( c==0xff00ff ) {
				// iFj͂̂܂܏Ƃ
				pal[i>>2] = c;
			} else {
				pal[i>>2] = ((c&0xf80000)>>8)|((c&0xfc00)>>5)|((c&0xf8)>>3);
			}
		}
		w = width  = buf[18]|(buf[19]<<8)|(buf[20]<<16)|(buf[21]<<24);
		h = height = buf[22]|(buf[23]<<8)|(buf[24]<<16)|(buf[25]<<24);
		dx = ((pos+1)*160)-(width>>1);
		src = buf+1078;
		if ( dx<0 ) {
			w += dx;
			src -= dx;
			dx = 0;
		}
		if ( (dx+width)>640 ) {
			w = 640-dx;
		}
		dst = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^1]);
		dst += 479*640+dx;				// BMPf[^͏㉺]Ă̂
		pad = 640+w;
		for (y=0; y<h; y++) {
			for (x=0; x<w; x++) {
				unsigned int register c0 = pal[src[x]];
				if ( c0!=0x00ff00ff ) {		// ^͓F
					*dst = c0;
				}
				dst++;
			}
			dst -= pad;
			src += width;
		}
		DisposeHeapPtr(buf);
	}
}


void Sys_SetChr(char* file, unsigned char num, unsigned char pos)
{
	if ( num>1 ) return;
	if ( pos>2 ) pos = 1;
	if ( file[0] ) {
		Sys_HideWindow();
		Sys_Update(WINX, WINY, WINX+WINW-1, WINY+WINH-1);
		strncpy(savedata.curchr[num], file, 16);
		savedata.curchrpos[num] = pos;
	} else {
		Sys_HideWindow();
		Sys_Update(WINX, WINY, WINX+WINW-1, WINY+WINH-1);
		memset(savedata.curchr[num], 0, 16);
	}
}


// -----------------------------------------------------------------------------------------
//   rbg}bvACe̕\
//     24bitFBMP̕\[`
// -----------------------------------------------------------------------------------------
void Sys_PutBitmapItem(int sx, int sy, int w, int h, int dx, int dy, int scr)
{
	unsigned char *src, *srcbuf;
	unsigned short *dst, *dstbuf, *tmp, *tmpbuf;
	int x, y, size;

	// ǂݍ܂ĂȂȂǂݍ
	if ( !ItemBitmap ) {
		ItemBitmap = ArcFile_Load("ETC23", &size);
		if ( !ItemBitmap ) return;
	}
	srcbuf = ItemBitmap+640*3*(479-sy)+sx*3+0x36;
	dstbuf = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^scr]);
	tmpbuf = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^(scr^1)]);
	dstbuf += 640*dy+dx;
	tmpbuf += 640*dy+dx;
	for (y=0; y<h; y++) {
		src = srcbuf;
		dst = dstbuf;
		tmp = tmpbuf;
		for (x=0; x<w; x++) {
			if ( (src[0]==0xff)&&(src[1]==0x00)&&(src[2]==0xff) ) {		// ^͓F
				*dst = *tmp;
			} else {
				*dst = ((src[2]&0xf8)<<8)|((src[1]&0xfc)<<3)|((src[0]&0xf8)>>3);
			}
			src += 3;
			dst++;
			tmp++;
		}
		srcbuf -= 640*3;
		dstbuf += 640;
		tmpbuf += 640;
	}
}


// `͏ɗ  F͉Ȃ
// t\Ŏgp
void Sys_PutBitmapItem2(int sx, int sy, int w, int h, int dx, int dy)
{
	unsigned char *src, *srcbuf;
	unsigned short *dst, *dstbuf;
	int x, y, size;

	// ǂݍ܂ĂȂȂǂݍ
	if ( !ItemBitmap ) {
		ItemBitmap = ArcFile_Load("ETC23", &size);
		if ( !ItemBitmap ) return;
	}
	srcbuf = ItemBitmap+640*3*(479-sy)+sx*3+0x36;
	dstbuf = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^1]);
	dstbuf += 640*dy+dx;
	for (y=0; y<h; y++) {
		src = srcbuf;
		dst = dstbuf;
		for (x=0; x<w; x++) {
			if ( (src[0]!=0xff)||(src[1]!=0x00)||(src[2]!=0xff) ) {		// ^͓F
				*dst = ((src[2]&0xf8)<<8)|((src[1]&0xfc)<<3)|((src[0]&0xf8)>>3);
			}
			src += 3;
			dst++;
		}
		srcbuf -= 640*3;
		dstbuf += 640;
	}
}


// -----------------------------------------------------------------------------------------
//   tÕZbgƎ擾
// -----------------------------------------------------------------------------------------
void Sys_SetFlag(int flagtype, int num, short val)
{
	if ( (flagtype<0)||(flagtype>2)||(num<0)||(num>255) ) {
		Error("Error : Flag out of range");
		return;
	}
	if ( flagtype==FLAG_SYSTEM )
		sysdata.SystemFlag[num] = val;
	else
		savedata.flag[flagtype][num] = val;
}


short Sys_GetFlag(int flagtype, int num)
{
	if ( (flagtype<0)||(flagtype>2)||(num<0)||(num>255) ) {
		Error("Error : Flag out of range");
		return 0;
	}
	if ( flagtype==FLAG_SYSTEM )
		return (sysdata.SystemFlag[num]);
	else
		return (savedata.flag[flagtype][num]);
}


// -----------------------------------------------------------------------------------------
//   ǃtOǗ
// -----------------------------------------------------------------------------------------
unsigned char* Sys_LoadScript(char* file, int* size)
{
	int i, j, n;
	unsigned char *ret;

	ret = ArcFile_LoadScript(file, size);

	if ( ret ) {
		i = ArcFile_GetFileNumber(file);
		if ( (i>=492)&&(i<572) ) {
			i -= 492;
			scriptnum = i;
			n = 0;
//			memset(readflag, 0, 8*180*2);
			for (j=0; (j<(*size))&&(n<8*180); j++) {
				if ( ret[j]==0x15 ) {
					readflag[n++] = j;
				}
			}
			maxreadflag = n;
		}
	}

	return ret;
}


int Sys_GetReadFlag(unsigned short pos)
{
	int mn, mx, cur, i, n, ret = 0;

	mn = 0;
	mx = maxreadflag;
	for (i=0; i<12; i++) {		// up to 4096
		cur = (mn+mx)>>1;
		if ( readflag[cur]==pos ) {
			return cur;
		} else if ( readflag[cur]<pos ) {
			mn = cur;
		} else {
			mx = cur;
		}
	}
	return 0;
}


int Sys_CheckReadFlag(void)
{
	unsigned char n;
	int ret = 0;

	n = 1;
	n <<= (curreadflag&7);
	ret = ((sysdata.ReadFlag[scriptnum][curreadflag>>3]&n)?1:0);
	return ret;
}

void Sys_SetReadFlag(void)
{
	unsigned char n;
	n = 1;
	n <<= (curreadflag&7);
	sysdata.ReadFlag[scriptnum][curreadflag>>3] |= n;
}


// -----------------------------------------------------------------------------------------
//   X^bN
// -----------------------------------------------------------------------------------------
void Sys_PushStack(unsigned short* pos, char* seen)
{
	if ( savedata.stacknum<MAX_STACK ) {
		savedata.stackpos[savedata.stacknum] = *pos;
		strncpy(savedata.stackseen[savedata.stacknum], seen, 16);
		savedata.stacknum++;
	} else {
		Error("Error : Stack overflow");
	}
}


void Sys_PopStack(unsigned short* pos, char* seen)
{
	if ( savedata.stacknum>0 ) {
		savedata.stacknum--;
		*pos = savedata.stackpos[savedata.stacknum];
		strncpy(seen, savedata.stackseen[savedata.stacknum], 16);
	} else {
		Error("Error : Stack underflow");
	}
}


// -----------------------------------------------------------------------------------------
//   EFCg֘A
// -----------------------------------------------------------------------------------------
void Sys_SetWaitSkip(char sw)
{
	savedata.waitskipflag = sw;
	if ( !sw ) {
		SkippingFlag = 0;
		MouseButtonFlag = 0;
	}
}


void Sys_StartWait(int t)
{
	SysState = SYS_STATE_WAIT;
	CurWait = t;
	WaitBase = Sys_GetCurrentTimer();
}

// -----------------------------------------------------------------------------------------
//   GtFNg֘A
// -----------------------------------------------------------------------------------------
void Sys_StartEffect(int n)
{
	SysState = SYS_STATE_EFFECT;
	CurEffect = n;
	CurEfStep = 0;
}


static const char EFFADEX[4] = {0,1,1,0};
static const char EFFADEY[4] = {0,1,0,1};
static const char EFFFADE16X[16] = {0,2,0,2,1,3,1,3,0,2,0,2,1,3,1,3};
static const char EFFFADE16Y[16] = {0,2,2,0,1,3,3,1,1,3,3,1,0,2,2,0};

void Sys_Effect(void)
{
	unsigned short *src, *dst, *srcbuf, *dstbuf, *srcbk, *dstbk;
	int x, y, n, dif;

	// }EXNbN͎cCɕ\
	if ( (GetMouseButton())||(SkippingFlag)||(sysdata.CfgEffectMode) ) {
		CurEffect=EF_IMM;
	}

	srcbuf = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^1]);
	dstbuf = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr]);

	switch ( CurEffect )
	{
		case 0x05:		// ㉺烉C
			n = (((CurEfStep%60)<<2)+(CurEfStep/60))<<1;
			src = srcbuf+n*640;
			dst = dstbuf+n*640;
			for (x=0; x<1280; x++) {
				*dst++ = *src++;
			}
			Sys_Update(0, n, 639, n+1);
			n = (((59-(CurEfStep%60))<<2)+(CurEfStep/60)+2)<<1;
			src = srcbuf+n*640;
			dst = dstbuf+n*640;
			for (x=0; x<1280; x++) {
				*dst++ = *src++;
			}
			Sys_Update(0, n, 639, n+1);

			CurEfStep++;
			if ( CurEfStep>=120 ) {
				SysState = SYS_STATE_NONE;
			}
			break;

		case 0x07:		// E烉C
			n = (((CurEfStep%80)<<2)+(CurEfStep/80))<<1;
			src = srcbuf+n;
			dst = dstbuf+n;
			for (y=0; y<480; y++) {
				dst[0] = src[0];
				dst[1] = src[1];
				dst += 640;
				src += 640;
			}
			Sys_Update(n, 0, n+1, 479);
			n = (((79-(CurEfStep%80))<<2)+(CurEfStep/80)+2)<<1;
			src = srcbuf+n;
			dst = dstbuf+n;
			for (y=0; y<480; y++) {
				dst[0] = src[0];
				dst[1] = src[1];
				dst += 640;
				src += 640;
			}
			Sys_Update(n, 0, n+1, 479);

			CurEfStep++;
			if ( CurEfStep>=160 ) {
				SysState = SYS_STATE_NONE;
			}
			break;

		case 0x06:		// Fade
		case 0x08:
			srcbuf += EFFADEY[CurEfStep]*640+EFFADEX[CurEfStep];
			dstbuf += EFFADEY[CurEfStep]*640+EFFADEX[CurEfStep];
			for(y=EFFADEY[CurEfStep]; y<480; y+=2) {
				src = srcbuf;
				dst = dstbuf;
				for (x=EFFADEX[CurEfStep]; x<640; x+=2) {
					*dst = *src;
					src += 2;
					dst += 2;
				}
				srcbuf += 1280;
				dstbuf += 1280;
			}
			CurEfStep++;
			if ( CurEfStep>=4 ) {
				SysState = SYS_STATE_NONE;
			}
			Sys_Update(0, 0, 639, 479);
			break;

		case 0x100:		// Wipe
			SysState = SYS_STATE_NONE;
			break;

		case EF_SCROLL:
			srcbk = srcbuf;
			dstbk = dstbuf;
			for (n=0; n<16; n++) {
				dif = CurEfStep-n;
				srcbuf = srcbk;
				dstbuf = dstbk;
				if ( (dif>=0)&&(dif<4) ) {
					srcbuf = srcbk+EFFADEY[dif]*640+EFFADEX[dif];
					dstbuf = dstbk+EFFADEY[dif]*640+EFFADEX[dif];
					for(y=EFFADEY[dif]; y<480; y+=2) {
						src = srcbuf;
						dst = dstbuf;
						for (x=EFFADEX[dif]; x<40; x+=2) {
							*dst = *src;
							src += 2;
							dst += 2;
						}
						srcbuf += 1280;
						dstbuf += 1280;
					}
					Sys_Update(n*40, 0, n*40+39, 479);
				}
				srcbk += 40;
				dstbk += 40;
			}
			CurEfStep++;
			if ( CurEfStep>=19 ) {
				SysState = SYS_STATE_NONE;
			}
			break;

		case EF_IMM:		// uԕ\
//			PrimScr ^= 1;
			memcpy(dstbuf, srcbuf, 640*480*2);
			SysState = SYS_STATE_NONE;
			Sys_Update(0, 0, 639, 479);
			break;
	}
}


// -----------------------------------------------------------------------------------------
//   bZ[W֘A
// -----------------------------------------------------------------------------------------
static const unsigned char H2ZTable[0x60] = {
	0x40, 0x49, 0x68, 0x94, 0x90, 0x93, 0x95, 0x66, 0x69, 0x6a, 0x96, 0x7b, 0x43, 0x7c, 0x44, 0x5e,
	0x4f, 0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x46, 0x47, 0x83, 0x81, 0x84, 0x48,
	0x97, 0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e,
	0x6f, 0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x6d, 0x8f, 0x6e, 0x4f, 0x51,
	0x65, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x8a, 0x8b, 0x8c, 0x8d, 0x8e, 0x8f,
	0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99, 0x9a, 0x6f, 0x62, 0x70, 0x60, 0x45
};


void Sys_AddLog(void)
{
	strcpy(LogBuffer[LogEnd], MessageBuffer);
	LogEnd = (LogEnd+1)%MAXLOG;
	if ( LogEnd==LogStart ) LogStart = (LogStart+1)%MAXLOG;
}


void Sys_StartMessage(char* mes, unsigned short pos)
{
	char* ptr = MessageBuffer;
	unsigned char c;

	curreadflag = Sys_GetReadFlag(pos);

	if ( Sys_CheckReadFlag() ) {
		if ( sysdata.CfgSkipMode==2 ) {
			SkippingFlag = 1;
		}
	} else {
		if ( sysdata.CfgSkipMode ) {
			SkippingFlag = 0;
		}
	}

	do {
		c = *mes++;
		if ( c>=0x80 ) {			// c >= 0x80
			*ptr++ = c;
			*ptr++ = *mes++;
		} else if ( c==0x10 ) {		// O̒u
			strcpy(ptr, savedata.firstname);
			ptr += strlen(savedata.firstname);
		} else if ( c==0x11 ) {		// c̒u
			strcpy(ptr, savedata.lastname);
			ptr += strlen(savedata.lastname);
		} else if ( c>=0x20 ) {	// p͑Spɕϊ
			if ( ((c>='0')&&(c<='9')) || ((c>='A')&&(c<='Z')) || ((c>='a')&&(c<='z')) )
				*ptr++ = 0x82;
			else
				*ptr++ = 0x81;
			*ptr++ = H2ZTable[c-0x20];
		} else {
			*ptr++ = c;
		}
	} while (c);

	MesIndent = 0;
	MsgPtr = MessageBuffer;
	SysState = SYS_STATE_MESSAGE;
	Sys_AddLog();
}


// ֑`FbN@`i
static char IsKinsoku(unsigned short w)
{
	char ret = 0;
	switch ( w ) {
		case 0x8140:	// SpXy[X
		case 0x8141:	// A
		case 0x8142:	// B
		case 0x8148:	// H
		case 0x8149:	// I
		case 0x815b:	// [
		case 0x816a:	// j
		case 0x8176:	// v
		case 0x8178:	// x
		case 0x8184:	// 
		case 0x829f:	// 
		case 0x82a1:	// 
		case 0x82a3:	// 
		case 0x82a5:	// 
		case 0x82a7:	// 
		case 0x82c1:	// 
		case 0x82e1:	// 
		case 0x82e5:	// 
		case 0x82e7:	// 
		case 0x8340:	// @
		case 0x8342:	// B
		case 0x8344:	// D
		case 0x8346:	// F
		case 0x8348:	// H
		case 0x8362:	// b
		case 0x8383:	// 
		case 0x8385:	// 
		case 0x8387:	// 
			ret = 1;
			break;
	}
	return ret;
}


static void Sys_Message(void)
{
	POINT pt;
	COLOR fg, bg;
	CDSPMODE mode;
	int x, y;
	char str[3];
	unsigned char d, c = *MsgPtr++;
	unsigned short w;
	if ( c<0x20 ) {
		switch ( c ) {
			case 0x00:	// Message End
				MesX = 0;		// bZ[W̍Ō͉sĂH
				MesY++;
				SysState = SYS_STATE_NONE;
				Sys_SetReadFlag();
				break;
			case 0x01:	// CR
				MesX = MesIndent;
				MesY++;
				break;
			case 0x02:	// Window Draw / Clear
				MesX = 0;
				MesY = 0;
				Sys_DrawMessageWindow();
				Sys_Update(WINX, WINY, WINX+WINW-1, WINY+WINH-1);
				break;
			case 0x05:	// Click Wait
				SysState = SYS_STATE_MESCLICKWAIT;
				AnmCount = 0;
				AnmWaitBase = Sys_GetCurrentTimer();
				break;
		}
	} else {
		x = 38+6+MesX*12;		// pPʂŌvZ
		y = 338+6+MesY*30;
		bg.CValue = BLACK;
		fg.CValue = WHITE;
		str[0] = c;
		if ( c<0x80 ) {			// p
			str[1] = 0;
//			Sys_Update(x, y+3, x+13, y+25+3);
			MesX++;
		} else {			// Sp
			d = *MsgPtr++;
			if ( c==0x81 ) {
				if ( d==0x75 ) {		// u
					MesIndent = MesX+2;
				} else if ( d==0x76 ) {		// v
					MesIndent = 0;
				} else if ( d==0x83 ) {		//    i{CfgƂĈ
					MesIndent = MesX+2;
					d = 0x69;		//    j{Cfg
				} else if ( d==0x84 ) {
					MesIndent = 0;
					d = 0x6a;
				}
			} else if ( c==0x87 ) {				// @ˑ
				if ( (d>=0x54)&&(d<=0x5d) ) {		// I`XiViIŁuIIvoj
					str[0] = c = 0xed;
					d += 10;
				} else if ( (d>=0x40)&&(d<=0x53) ) {	// (1)`(20)
					str[0] = c = 0xed;
				}
			}
			str[1] = d;
			str[2] = 0;
			MesX += 2;
		}
		if ( (sysdata.CfgFontMode)&&(!VGAFlag) ) {
			mode = FSET+QP48_CHR;		// 24dotŒ
			pt.x = (((x+2)>>1)<<2);
			pt.y = (((y+25+3)>>1)<<2);
			DispNChar(hBackScr, &pt, &bg, &bg, mode, str, strlen(str), 24, NULL);
			pt.x = ((x>>1)<<2);
			pt.y = (((y+23+3)>>1)<<2);
			DispNChar(hBackScr, &pt, &fg, &fg, mode, str, strlen(str), 24, NULL);
			Sys_Update2(x, y+3, x+25, y+25+3);
		} else {
			mode = FSET+QP96_CHR;		// 24dotŒ
			pt.x = ((x+2)<<2);
			pt.y = ((y+25+3)<<2);
			DispNChar(hScr[PrimScr], &pt, &bg, &bg, mode, str, strlen(str), 48, NULL);
			pt.x = (x<<2);
			pt.y = ((y+23+3)<<2);
			DispNChar(hScr[PrimScr], &pt, &fg, &fg, mode, str, strlen(str), 48, NULL);
			Sys_Update(x, y+3, x+25, y+25+3);
		}
		if ( MesX>=43 ) {
			// ֑B
			// sŏ֑̏̕ꍇAOs̍Ōɕ`B
			// AAONȄꍇA֑ꍇ͂̏͂ȂB
			w = (unsigned char)MsgPtr[0];
			w = (w<<8)|((unsigned char)MsgPtr[1]);
			if ( IsKinsoku(w) ) {
				w = (unsigned char)MsgPtr[2];
				w = (w<<8)|((unsigned char)MsgPtr[3]);
				if ( (IsKinsoku(w))||(MesX>=45) ) {
					MesX = MesIndent;
					MesY++;
				}
			} else {
				MesX = MesIndent;
				MesY++;
			}
		}
	}
}


static void Sys_MessageFast(void)
{
	POINT pt;
	COLOR fg, bg;
	CDSPMODE mode;
	int x, y;
	char str[3];
	unsigned char d, c;
	unsigned short w;

	while (1) {
		c = *MsgPtr++;
		if ( !c ) {
			// Message End
			MesX = 0;
			MesY++;
			SysState = SYS_STATE_NONE;
			Sys_SetReadFlag();
			break;
		} else if ( c<0x20 ) {
			switch ( c ) {
				case 0x01:	// CR
					MesX = MesIndent;
					MesY++;
					break;
				case 0x02:	// Window Draw / Clear
					MesX = 0;
					MesY = 0;
					Sys_DrawMessageWindow();
					Sys_Update(WINX, WINY, WINX+WINW-1, WINY+WINH-1);
					break;
				case 0x05:	// Click Wait
					SysState = SYS_STATE_MESCLICKWAIT;
					AnmCount = 0;
					AnmWaitBase = Sys_GetCurrentTimer();
					if ( (sysdata.CfgFontMode)&&(!VGAFlag) )
						Sys_Update2(WINX, WINY, WINX+WINW-1, WINY+WINH-1);	// Sĕ\
					else
						Sys_Update(WINX, WINY, WINX+WINW-1, WINY+WINH-1);	// Sĕ\
					return;
			}
			continue;
		}

		x = 38+6+MesX*12;			// pPʂŌvZ
		y = 338+6+MesY*30;
		bg.CValue = BLACK;
		fg.CValue = WHITE;
		mode = FSET+QP96_CHR;		// 24dotŒ
		str[0] = c;
		if ( c<0x80 ) {			// p
			str[1] = 0;
			MesX++;
		} else {			// Sp
			d = *MsgPtr++;
			if ( c==0x81 ) {
				if ( d==0x75 ) {		// u
					MesIndent = MesX+2;
				} else if ( d==0x76 ) {		// v
					MesIndent = 0;
				} else if ( d==0x83 ) {		//    i{CfgƂĈ
					MesIndent = MesX+2;
					d = 0x69;		//    j{Cfg
				} else if ( d==0x84 ) {
					MesIndent = 0;
					d = 0x6a;
				}
			} else if ( (c==0x87)&&(d>=0x54)&&(d<=0x5d) ) {	// @ˑ́uI`XviViIŁuIIvoj
				str[0] = c = 0xed;
				d += 10;
			}
			str[1] = d;
			str[2] = 0;
			MesX += 2;
		}
		if ( (sysdata.CfgFontMode)&&(!VGAFlag) ) {
			mode = FSET+QP48_CHR;		// 24dotŒ
			pt.x = (((x+2)>>1)<<2);
			pt.y = (((y+25+3)>>1)<<2);
			DispNChar(hBackScr, &pt, &bg, &bg, mode, str, strlen(str), 24, NULL);
			pt.x = ((x>>1)<<2);
			pt.y = (((y+23+3)>>1)<<2);
			DispNChar(hBackScr, &pt, &fg, &fg, mode, str, strlen(str), 24, NULL);
		} else {
			mode = FSET+QP96_CHR;		// 24dotŒ
			pt.x = ((x+2)<<2);
			pt.y = ((y+25+3)<<2);
			DispNChar(hScr[PrimScr], &pt, &bg, &bg, mode, str, strlen(str), 48, NULL);
			pt.x = (x<<2);
			pt.y = ((y+23+3)<<2);
			DispNChar(hScr[PrimScr], &pt, &fg, &fg, mode, str, strlen(str), 48, NULL);
		}
		if ( MesX>=43 ) {
			// ֑B
			// sŏ֑̏̕ꍇAOs̍Ōɕ`B
			// AAONȄꍇA֑ꍇ͂̏͂ȂB
			w = (unsigned char)MsgPtr[0];
			w = (w<<8)|((unsigned char)MsgPtr[1]);
			if ( IsKinsoku(w) ) {
				w = (unsigned char)MsgPtr[2];
				w = (w<<8)|((unsigned char)MsgPtr[3]);
				if ( (IsKinsoku(w))||(MesX>=45) ) {
					MesX = MesIndent;
					MesY++;
				}
			} else {
				MesX = MesIndent;
				MesY++;
			}
		}
	}
	if ( (sysdata.CfgFontMode)&&(!VGAFlag) )
		Sys_Update2(WINX, WINY, WINX+WINW-1, WINY+WINH-1);	// Sĕ\
	else
		Sys_Update(WINX, WINY, WINX+WINW-1, WINY+WINH-1);	// Sĕ\
}


static void Sys_StartLog(void)
{
	POINT pt;
	COLOR fg, bg;
	CDSPMODE mode;
	int x, y;
	char str[3];
	unsigned char d, c;
	unsigned short w;

	MesX = 0;
	MesY = 0;
	MesIndent = 0;
	Sys_DrawMessageWindow();
	if ( (sysdata.CfgFontMode)&&(!VGAFlag) )
		Sys_Update(WINX, WINY, WINX+WINW-1, WINY+WINH-1);	// Sĕ\
	MsgPtr = LogBuffer[CurLogPage];

	while (1) {
		c = *MsgPtr++;
		if ( !c ) {
			// Message End
			MesX = 0;
			MesY++;
			SysState = SYS_STATE_LOGWAIT;
			break;
		} else if ( c<0x20 ) {
			switch ( c ) {
				case 0x01:	// CR
					MesX = MesIndent;
					MesY++;
					break;
				case 0x02:	// Window Draw / Clear
					break;
				case 0x05:	// Click Wait
					break;
			}
			continue;
		}

		x = 38+6+MesX*12;			// pPʂŌvZ
		y = 338+6+MesY*30;
		bg.CValue = BLACK;
		fg.CValue = 0xaaffcc;
		mode = FSET+QP96_CHR;		// 24dotŒ
		str[0] = c;
		if ( c<0x80 ) {			// p
			str[1] = 0;
			MesX++;
		} else {			// Sp
			d = *MsgPtr++;
			if ( c==0x81 ) {
				if ( d==0x75 ) {		// u
					MesIndent = MesX+2;
				} else if ( d==0x76 ) {		// v
					MesIndent = 0;
				} else if ( d==0x83 ) {		//    i{CfgƂĈ
					MesIndent = MesX+2;
					d = 0x69;		//    j{Cfg
				} else if ( d==0x84 ) {
					MesIndent = 0;
					d = 0x6a;
				}
			} else if ( (c==0x87)&&(d>=0x54)&&(d<=0x5d) ) {	// @ˑ́uI`XviViIŁuIIvoj
				str[0] = c = 0xed;
				d += 10;
			}
			str[1] = d;
			str[2] = 0;
			MesX += 2;
		}
		if ( (sysdata.CfgFontMode)&&(!VGAFlag) ) {
			mode = FSET+QP48_CHR;		// 24dotŒ
			pt.x = (((x+2)>>1)<<2);
			pt.y = (((y+25+3)>>1)<<2);
			DispNChar(hBackScr, &pt, &bg, &bg, mode, str, strlen(str), 24, NULL);
			pt.x = ((x>>1)<<2);
			pt.y = (((y+23+3)>>1)<<2);
			DispNChar(hBackScr, &pt, &fg, &fg, mode, str, strlen(str), 24, NULL);
		} else {
			mode = FSET+QP96_CHR;		// 24dotŒ
			pt.x = ((x+2)<<2);
			pt.y = ((y+25+3)<<2);
			DispNChar(hScr[PrimScr], &pt, &bg, &bg, mode, str, strlen(str), 48, NULL);
			pt.x = (x<<2);
			pt.y = ((y+23+3)<<2);
			DispNChar(hScr[PrimScr], &pt, &fg, &fg, mode, str, strlen(str), 48, NULL);
		}
		if ( MesX>=43 ) {
			// ֑B
			// sŏ֑̏̕ꍇAOs̍Ōɕ`B
			// AAONȄꍇA֑ꍇ͂̏͂ȂB
			w = (unsigned char)MsgPtr[0];
			w = (w<<8)|((unsigned char)MsgPtr[1]);
			if ( IsKinsoku(w) ) {
				w = (unsigned char)MsgPtr[2];
				w = (w<<8)|((unsigned char)MsgPtr[3]);
				if ( (IsKinsoku(w))||(MesX>=45) ) {
					MesX = MesIndent;
					MesY++;
				}
			} else {
				MesX = MesIndent;
				MesY++;
			}
		}
	}
	if ( (sysdata.CfgFontMode)&&(!VGAFlag) )
		Sys_Update2(WINX, WINY, WINX+WINW-1, WINY+WINH-1);	// Sĕ\
	else
		Sys_Update(WINX, WINY, WINX+WINW-1, WINY+WINH-1);	// Sĕ\
}


// -----------------------------------------------------------------------------------------
//   I֘A
// -----------------------------------------------------------------------------------------
void Sys_AddSelect(char* mes)
{
	POINT pt;
	COLOR fg, bg;
	CDSPMODE mode;
	int x, y;

	// ŏ̃ACeȂEBhE`
	if ( !SelMaxItem ) {
		Sys_DrawMessageWindow();
		if ( (sysdata.CfgFontMode)&&(!VGAFlag) )
			Sys_Update(WINX, WINY, WINX+WINW-1, WINY+WINH-1);
	}

	// IACe`
	// ̎_ł͂܂obNobt@ɂ̂ݕ`Aʂɂ͏oȂ
	x = 38+6+36;			// pPʂŌvZ
	y = 338+6+SelMaxItem*30;
	bg.CValue = BLACK;
	fg.CValue = GRAY;
	if ( (sysdata.CfgFontMode)&&(!VGAFlag) ) {
		mode = FSET+QP48_CHR;		// 24dotŒ
		pt.x = (((x+2)>>1)<<2);
		pt.y = (((y+25+3)>>1)<<2);
		DispNChar(hBackScr, &pt, &bg, &bg, mode, mes, strlen(mes), 24, NULL);
		pt.x = ((x>>1)<<2);
		pt.y = (((y+23+3)>>1)<<2);
		DispNChar(hBackScr, &pt, &fg, &fg, mode, mes, strlen(mes), 24, NULL);
	} else {
		mode = FSET+QP96_CHR;		// 24dotŒ
		pt.x = ((x+2)<<2);
		pt.y = ((y+25+3)<<2);
		DispNChar(hScr[PrimScr], &pt, &bg, &bg, mode, mes, strlen(mes), 48, NULL);
		pt.x = (x<<2);
		pt.y = ((y+23+3)<<2);
		DispNChar(hScr[PrimScr], &pt, &fg, &fg, mode, mes, strlen(mes), 48, NULL);
	}
	strcpy(SelItemStr[SelMaxItem], mes);
	SelMaxItem++;
}


void Sys_StartSelect(short result)
{
	if ( (sysdata.CfgFontMode)&&(!VGAFlag) )
		Sys_Update2(WINX, WINY, WINX+WINW-1, WINY+WINH-1);	// Sĕ\
	else
		Sys_Update(WINX, WINY, WINX+WINW-1, WINY+WINH-1);	// Sĕ\
	SelResult = result;
	SelItem = -1;
	SysState = SYS_STATE_SELECT;
	SkippingFlag = 0;
	Sys_MouseMove(0, 0);
}


static void Sys_Select(void)
{
	POINT pt;
	COLOR fg, bg;
	CDSPMODE mode;
	short x, y, n, old = SelItem;

	// L[͂őIł悤ɂ邽߂̍׍H
	if ( KeyCode==KEY_UP ) {
		if ( SelItem==-1 ) {
			Sys_MouseMove(320, (SelMaxItem-1)*30+348);
		} else if ( SelItem ) {
			Sys_MouseMove(320, (SelItem-1)*30+348);
		}
	} else if ( KeyCode==KEY_DOWN ) {
		if ( (SelItem+1)<SelMaxItem ) {
			Sys_MouseMove(320, (SelItem+1)*30+348);
		}
	}
	KeyCode = 0;

	GetMousePos(&x, &y);
	n = (y-(338+6))/30;
	if ( (x>=44)&&(x<596)&&(y>=(338+6))&&(n<SelMaxItem) ) {
		SelItem = n;
	} else {
		SelItem = -1;
	}
	if ( old!=SelItem ) {
		if ( old!=-1 ) {
			x = 38+6+36;			// pPʂŌvZ
			y = 338+6+old*30;
			fg.CValue = GRAY;
			bg.CValue = BLACK;
			if ( (sysdata.CfgFontMode)&&(!VGAFlag) ) {
				mode = FSET+QP48_CHR;		// 24dotŒ
				pt.x = ((x>>1)<<2);
				pt.y = (((y+23+3)>>1)<<2);
				DispNChar(hBackScr, &pt, &fg, &fg, mode, SelItemStr[old], strlen(SelItemStr[old]), 24, NULL);
				Sys_Update2(38+6+36, y, 601, y+23+3);	// \
			} else {
				mode = FSET+QP96_CHR;		// 24dotŒ
				pt.x = (x<<2);
				pt.y = ((y+23+3)<<2);
				DispNChar(hScr[PrimScr], &pt, &fg, &fg, mode, SelItemStr[old], strlen(SelItemStr[old]), 48, NULL);
				Sys_Update(38+6+36, y, 601, y+23+3);	// \
			}
			x = 38+12;
			y = old*30+344;
			Sys_PutBitmapItem(230, 0, 20, 20, x, y, 0);
			Sys_Update(x, y, x+19, y+19);
		}
		if ( SelItem!=-1 ) {
			x = 38+6+36;			// pPʂŌvZ
			y = 338+6+SelItem*30;
			fg.CValue = WHITE;
			bg.CValue = BLACK;
			if ( (sysdata.CfgFontMode)&&(!VGAFlag) ) {
				mode = FSET+QP48_CHR;		// 24dotŒ
				pt.x = ((x>>1)<<2);
				pt.y = (((y+23+3)>>1)<<2);
				DispNChar(hBackScr, &pt, &fg, &fg, mode, SelItemStr[SelItem], strlen(SelItemStr[SelItem]), 24, NULL);
				Sys_Update2(38+6+36, y, 601, y+23+3);	// \
			} else {
				mode = FSET+QP96_CHR;		// 24dotŒ
				pt.x = (x<<2);
				pt.y = ((y+23+3)<<2);
				DispNChar(hScr[PrimScr], &pt, &fg, &fg, mode, SelItemStr[SelItem], strlen(SelItemStr[SelItem]), 48, NULL);
				Sys_Update(38+6+36, y, 601, y+23+3);	// \
			}
			x = 38+12;
			y = SelItem*30+344;
			Sys_PutBitmapItem(10, 40, 20, 20, x, y, 0);
			Sys_Update(x, y, x+19, y+19);
		}
	}
	if ( GetMouseButton() ) {
		if ( SelItem!=-1 ) {
			// IiIj
			SelMaxItem = 0;
			Sys_SetFlag(FLAG_COUNT, SelResult, SelItem+1);		// ʂJE^tOɃZbgi1`nj
			SysState = SYS_STATE_NONE;
			return;
		}
	}
}
// -----------------------------------------------------------------------------------------
//   J_[
// -----------------------------------------------------------------------------------------
static const char* const CalFile[] = {
	"", "ETC18", "ETC19", "ETC20", "ETC21", "", "", "", "", "", "", "ETC16", "ETC17"
};

void Sys_StartCalender(void) {
	Sys_SetBG((char*)CalFile[savedata.flag[FLAG_COUNT][0]]);
	Sys_LoadBG();
	memset(savedata.curbg, 0, 16);
	Sys_StartEffect(6);
	SysState = SYS_STATE_CAL_FADEIN;
}


// -----------------------------------------------------------------------------------------
//   ^Cgj[
// -----------------------------------------------------------------------------------------
void Sys_StartTitleMenu(short result)
{
	Sys_SetBG("ETC00");
	Sys_LoadBG();
	savedata.curbg[0] = 0;

	SelResult = result;		// Select̂g܂킻
	SelItem = -1;
	SkippingFlag = 0;		// XLbv~
	Sys_MouseMove(0, 0);		// IĂȂԂɂ
	Sys_StartEffect(6);
	SysState = SYS_STATE_MAINMENUFADE;
}


static void Sys_TitleMenu(void)
{
	short x, y, old = SelItem;

	// L[͂őIł悤ɂ邽߂̍׍H
	if ( KeyCode==KEY_UP ) {
		if ( SelItem==-1 ) {
			Sys_MouseMove(320, 4*44+222);
		} else if ( SelItem ) {
			Sys_MouseMove(320, (SelItem-1)*44+222);
		}
	} else if ( KeyCode==KEY_DOWN ) {
		if ( SelItem<4 ) {
			Sys_MouseMove(320, (SelItem+1)*44+222);
		}
	}
	KeyCode = 0;

	GetMousePos(&x, &y);
	if ( (x>=210)&&(x<445)&&(y>=219)&&(y<439) ) {
		SelItem = (y-219)/44;
	} else {
		SelItem = -1;
	}

	if ( old!=SelItem ) {
		if ( old!=-1 ) {
			Sys_ExchangePixel(210, old*44+219, 290, 44, 0, old*44+4);
			Sys_Update(210, old*44+219, 445, old*44+262);
		}
		if ( SelItem!=-1 ) {
			Sys_ExchangePixel(210, SelItem*44+219, 290, 44, 0, SelItem*44+4);
			Sys_Update(210, SelItem*44+219, 445, SelItem*44+262);
		}
	}
	if ( GetMouseButton() ) {
//		if ( SelItem!=-1 ) {
// StartEndIׂ悤ɂĂîƂ́Aˁj
if ( (SelItem==0)||(SelItem==3)||(SelItem==4) ) {
			// IiIj
			SelMaxItem = 0;
			Sys_SetFlag(FLAG_COUNT, SelResult, SelItem);		// ʂJE^tOɃZbgi1`nj
			SysState = SYS_STATE_NONE;
		}
	}
}


// -----------------------------------------------------------------------------------------
//   ܂j[
// -----------------------------------------------------------------------------------------
void Sys_StartAppendixMenu(short result)
{
	Sys_LoadJpegItem();

	Sys_SetBG("ETC02");
	Sys_LoadBG();
	savedata.curbg[0] = 0;

	SelResult = result;		// Select̂g܂킻
	SelItem = -1;
	SkippingFlag = 0;		// XLbv~
	Sys_MouseMove(0, 0);		// IĂȂԂɂ
	Sys_StartEffect(6);
	SysState = SYS_STATE_APPENDMENUFADE;
}


static void Sys_AppendixMenu(void)
{
	const int ypos[3] = {114, 179, 239};
	short x, y, old = SelItem, i;

	// L[͂őIł悤ɂ邽߂̍׍H
	if ( KeyCode==KEY_UP ) {
		if ( SelItem==-1 ) {
			Sys_MouseMove(320, ypos[0]+5);
		} else if ( SelItem ) {
			Sys_MouseMove(320, ypos[SelItem-1]+5);
		}
	} else if ( KeyCode==KEY_DOWN ) {
		if ( SelItem<2 ) {
			Sys_MouseMove(320, ypos[SelItem+1]+5);
		}
	}
	KeyCode = 0;

	GetMousePos(&x, &y);
	SelItem = -1;
	if ( (x>=181)&&(x<445) ) {
		for (i=0; i<3; i++) {
			if ( (y>=ypos[i])&&(y<(ypos[i]+55)) ) SelItem = i;
		}
	}

	if ( old!=SelItem ) {
		if ( old!=-1 ) {
			Sys_ExchangePixel(181, ypos[old], 300, 55, 0, ypos[old]-114);
			Sys_Update(181, ypos[old], 445, ypos[old]+54);
		}
		if ( SelItem!=-1 ) {
			Sys_ExchangePixel(181, ypos[SelItem], 300, 55, 0, ypos[SelItem]-114);
			Sys_Update(181, ypos[SelItem], 445, ypos[SelItem]+54);
		}
	}
	if ( GetMouseButton() ) {
		if ( SelItem!=-1 ) {
			// IiIj
			SelMaxItem = 0;
			Sys_SetFlag(FLAG_COUNT, SelResult, SelItem);		// ʂJE^tOɃZbgi1`nj
			Sys_ClearBG();
			Sys_StartEffect(6);
		}
	}
}


// -----------------------------------------------------------------------------------------
//   CGLIj[
// -----------------------------------------------------------------------------------------
void Sys_StartCGCharMenu(short result)
{
	Sys_SetBG("ETC06");
	Sys_LoadBG();
	savedata.curbg[0] = 0;

	SelResult = result;		// Select̂g܂킻
	SelItem = -1;
	SkippingFlag = 0;		// XLbv~
	Sys_MouseMove(0, 0);		// IĂȂԂɂ
	Sys_StartEffect(5);
	SysState = SYS_STATE_CGCHARMENUFADE;
}


static void Sys_CGCharMenu(void)
{
	const int ypos[3] = {114, 179, 239};
	short x, y, old = SelItem, i;

	// L[͂őIł悤ɂ邽߂̍׍H
	if ( KeyCode==KEY_UP ) {
		if ( (SelItem>=3)&&(SelItem<=5) ) {
			Sys_MouseMove((SelItem-3)*102+120, 260);
		} else if ( SelItem==-1 ) {
			Sys_MouseMove(120, 365);
		}
	} else if ( KeyCode==KEY_DOWN ) {
		if ( (SelItem>=0)&&(SelItem<=2) ) {
			Sys_MouseMove(SelItem*102+120, 365);
		} else if ( SelItem==-1 ) {
			Sys_MouseMove(120, 260);
		}
	} else if ( KeyCode==KEY_LEFT ) {
		GetMouseButton();
		SkippingFlag = 0;
		if ( (SelItem==1)||(SelItem==2) ) {
			Sys_MouseMove((SelItem-1)*102+120, 260);
		} else if ( (SelItem>=4)&&(SelItem<=6) ) {
			Sys_MouseMove((SelItem-4)*102+120, 365);
		}
	} else if ( KeyCode==KEY_RIGHT ) {
		GetMouseButton();
		SkippingFlag = 0;
		if ( SelItem<=1 ) {
			Sys_MouseMove((SelItem+1)*102+120, 260);
		} else if ( (SelItem>=3)&&(SelItem<=5) ) {
			Sys_MouseMove((SelItem-2)*102+120, 365);
		}
	}
	KeyCode = 0;

	GetMousePos(&x, &y);
	SelItem = -1;
	if ( (x>=116)&&(x<524)&&(y>=258)&&(y<462) ) {
		SelItem = ((x-116)/102)+((y-258)/102)*4;
		if ( SelItem==3 ) SelItem = -1;
		else if ( SelItem>3 ) SelItem--;
	}

	if ( old!=SelItem ) {
		if ( old!=-1 ) {
			if ( old<3 ) {
				x = old*102+116;
				y = 258;
			} else {
				x = (old-3)*102+116;
				y = 360;
			}
			Sys_ExchangePixel(x, y, 102, 102, x, y);
			Sys_Update(x, y, x+101, y+101);
		}
		if ( SelItem!=-1 ) {
			if ( SelItem<3 ) {
				x = SelItem*102+116;
				y = 258;
			} else {
				x = (SelItem-3)*102+116;
				y = 360;
			}
			Sys_ExchangePixel(x, y, 102, 102, x, y);
			Sys_Update(x, y, x+101, y+101);
			if ( SelItem!=6 ) {
				x = ((SelItem&1)*100)+854;
				y = (SelItem>>1)*197;
				Sys_PutJpegItem(x, y, 93, 193, 10, 280, 0);
			} else {
				Sys_BltPixel(10, 280, 93, 193, 10, 280);
			}
		} else {
			Sys_BltPixel(10, 280, 93, 193, 10, 280);
		}
		Sys_Update(10, 280, 10+92, 280+192);
	}
	if ( GetMouseButton() ) {
		if ( SelItem!=-1 ) {
			// IiIj
			SelMaxItem = 0;
			Sys_SetFlag(FLAG_COUNT, SelResult, SelItem);		// ʂJE^tOɃZbgi1`nj
			SysState = SYS_STATE_NONE;
			if ( SelItem<3 ) {
				x = SelItem*284;
				y = 0;
			} else {
				x = (SelItem-3)*284;
				y = 258;
			}
			if ( SelItem!=6 ) {
				Sys_PutJpegItem(x, y, 283, 257, 0, 0, 0);
				Sys_Update(0, 0, 282, 256);
			}
			Sys_ClearBG();
			Sys_StartEffect(5);
		}
	}
}


// -----------------------------------------------------------------------------------------
//   CGIj[
// -----------------------------------------------------------------------------------------
const int CGSelStart[6] = {0, 24, 44, 65, 82, 101};
const int CGSelNums[6]  = {24, 20, 21, 17, 19, 25};
const int CGSelMax[6]   = {16, 16, 17, 13, 16, 14};
const int CGSelJpeg[6]   = {13, 11, 12, 10, 8, 9};
const int CGSelFlagTable[126] = {
	0, 1, 1, 1, 1, 2, 3, 4, 4, 4, 4, 4, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,	/* (24) */
	0, 1, 2, 3, 4, 5, 6, 6, 6, 7, 8, 9, 9, 10, 11, 12, 13, 13, 14, 15,		/* Y(20) */
	0, 1, 2, 3, 3, 4, 4, 5, 6, 7, 8, 9, 10, 10, 11, 12, 13, 14, 14, 15, 16,		/* ݂(21) */
	0, 1, 1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 12, 12,				/* (17) */
	0, 1, 2, 3, 4, 4, 5, 5, 6, 7, 8, 8, 9, 10, 11, 12, 13, 14, 15,			/* (19) */
	0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 3, 3, 4, 5, 6, 6, 6, 7, 7, 8, 9, 10, 11, 12, 13	/* (25) */
};

static int CGSelChar;
static char CGSelFlag[24];

void Sys_StartCGSelMenu(short result)
{
	char file[16];
	int i, st, num;

	CGSelChar = Sys_GetFlag(FLAG_COUNT, result);
	sprintf(file, "ETC%02d", CGSelJpeg[CGSelChar]);
	Sys_SetBG(file);
	Sys_LoadBG();
	savedata.curbg[0] = 0;

	memset(CGSelFlag, 0, 20);
	st = CGSelStart[CGSelChar];
	num = CGSelNums[CGSelChar];
	for (i=st; i<(st+num); i++) {
		if ( Sys_GetFlag(FLAG_SYSTEM, i) ) CGSelFlag[CGSelFlagTable[i]] = 1;
	}
	for (i=0; i<CGSelMax[CGSelChar]; i++) {
		if ( !CGSelFlag[i] ) {
			Sys_PutBitmapItem(447, 54, 120, 90, (i%5)*122+16, (i/5)*92+57, 1);
		}
	}

	SelResult = result;		// Select̂g܂킻
	SelItem = -1;
	SkippingFlag = 0;		// XLbv~
//	Sys_MouseMove(0, 0);		// IĂȂԂɂ
	Sys_StartEffect(6);
	SysState = SYS_STATE_CGNUMMENUFADE;
}


static void Sys_CGSelMenu(void)
{
	short x, y, old = SelItem, i;

	// L[͂őIł悤ɂ邽߂̍׍H
	if ( KeyCode==KEY_UP ) {
		if ( (SelItem>=5)&&(SelItem!=20) ) {
			Sys_MouseMove(((SelItem-5)%5)*122+25, ((SelItem-5)/5)*92+65);
		} else if ( (SelItem==-1)||(SelItem==20) ) {
			Sys_MouseMove(25, ((CGSelMax[CGSelChar]-1)/5)*92+65);
		}
	} else if ( KeyCode==KEY_DOWN ) {
		if ( (SelItem+5)<CGSelMax[CGSelChar] ) {
			Sys_MouseMove(((SelItem+5)%5)*122+25, ((SelItem+5)/5)*92+65);
		} else if ( SelItem==-1 ) {
			Sys_MouseMove(25, 65);
		} else if ( SelItem!=20 ) {
			Sys_MouseMove(200, 435);
		}
	} else if ( KeyCode==KEY_LEFT ) {
		GetMouseButton();
		SkippingFlag = 0;
		if ( (SelItem!=-1)&&(SelItem!=20)&&((SelItem%5)!=0) ) {
			Sys_MouseMove(((SelItem-1)%5)*122+25, ((SelItem-1)/5)*92+65);
		} else if ( SelItem==-1 ) {
			Sys_MouseMove(4*122+25, 65);
		}
	} else if ( KeyCode==KEY_RIGHT ) {
		GetMouseButton();
		SkippingFlag = 0;
		if ( (SelItem!=-1)&&(SelItem!=20)&&((SelItem%5)!=4)&&((SelItem+1)<CGSelMax[CGSelChar]) ) {
			Sys_MouseMove(((SelItem+1)%5)*122+25, ((SelItem+1)/5)*92+65);
		} else if ( SelItem==-1 ) {
			Sys_MouseMove(25, 65);
		}
	}
	KeyCode = 0;

	GetMousePos(&x, &y);
	SelItem = -1;
	if ( (x>=15)&&(x<625)&&(y>=56)&&(y<424) ) {
		SelItem = ((x-15)/122)+((y-56)/92)*5;
		if ( SelItem>=CGSelMax[CGSelChar] ) SelItem = -1;
	} else if ( (x>=191)&&(x<454)&&(y>=427)&&(y<478) ) {
		SelItem = 20;
	}

	if ( old!=SelItem ) {
		if ( old!=-1 ) {
			if ( old==20 ) {
				Sys_BltPixel(191, 427, 263, 51, 191, 427);
				Sys_Update(191, 427, 453, 477);
			} else {
				Sys_BltPixel((old%5)*122+16, (old/5)*92+57, 120, 90, (old%5)*122+16, (old/5)*92+57);
				Sys_Update((old%5)*122+16, (old/5)*92+57, (old%5)*122+16+119, (old/5)*92+57+89);
			}
		}
		if ( SelItem!=-1 ) {
			if ( SelItem==20 ) {
				Sys_PutBitmapItem(320, 0, 263, 51, 191, 427, 0);
				Sys_Update(191, 427, 453, 477);
			} else {
				Sys_PutBitmapItem(322, 54, 120, 90, (SelItem%5)*122+16, (SelItem/5)*92+57, 0);
				Sys_Update((SelItem%5)*122+16, (SelItem/5)*92+57, (SelItem%5)*122+16+119, (SelItem/5)*92+57+89);
			}
		}
	}
	if ( GetMouseButton() ) {
		if ( SelItem!=-1 ) {
			if ( (CGSelFlag[SelItem])||(SelItem==20) ) {
				// IiIj
				SelMaxItem = 0;
				Sys_SetFlag(FLAG_COUNT, SelResult, SelItem);		// ʂJE^tOɃZbgi1`nj
				SysState = SYS_STATE_NONE;
				if ( SelItem==20 ) {
					Sys_ClearBG();
					Sys_StartEffect(6);
				}
			}
		}
	}
}


// -----------------------------------------------------------------------------------------
//   BGMIj[
// -----------------------------------------------------------------------------------------
static int BGMCtrl = 0;

void Sys_StartBGMMenu(short result)
{
	SelResult = result;		// Select̂g܂킻
	SkippingFlag = 0;		// XLbv~

	if ( !BGMModeFlag ) {
		SelItem = -1;
		Sys_SetBG("ETC14");
		Sys_LoadBG();
		savedata.curbg[0] = 0;

		Sys_MouseMove(0, 0);		// IĂȂԂɂ
		Sys_StartEffect(7);
		BGMCtrl = 0;
	}
	SysState = SYS_STATE_BGMMENUFADE;
}

static void Sys_BGMMenu(void)
{
	short x, y, old = SelItem, i, ctrl = 0;

	// L[͂őIł悤ɂ邽߂̍׍H
	if ( KeyCode==KEY_UP ) {
		if ( (SelItem>0)&&(SelItem<7) ) {
			Sys_MouseMove(35, ((SelItem-1)*37)+200);
		} else if ( (SelItem>7)&&(SelItem<13) ) {
			Sys_MouseMove(231, ((SelItem-7)*37)+200);
		} else if ( (SelItem>13)&&(SelItem<20) ) {
			Sys_MouseMove(427, ((SelItem-14)*37)+200);
		} else if ( SelItem==-1 ) {
			Sys_MouseMove(35, 422);
		}
	} else if ( KeyCode==KEY_DOWN ) {
		if ( (SelItem>=0)&&(SelItem<6) ) {
			Sys_MouseMove(35, ((SelItem+1)*37)+200);
		} else if ( (SelItem>=7)&&(SelItem<12) ) {
			Sys_MouseMove(231, ((SelItem-5)*37)+200);
		} else if ( (SelItem>=13)&&(SelItem<19) ) {
			Sys_MouseMove(427, ((SelItem-12)*37)+200);
		} else if ( SelItem==-1 ) {
			Sys_MouseMove(35, 200);
		}
	} else if ( KeyCode==KEY_LEFT ) {
		GetMouseButton();
		SkippingFlag = 0;
		if ( (SelItem>=7)&&(SelItem<=12) ) {
			Sys_MouseMove(35, ((SelItem-6)*37)+200);
		} else if ( (SelItem>=14)&&(SelItem<=19) ) {
			Sys_MouseMove(231, ((SelItem-13)*37)+200);
		} else if ( SelItem==13 ) {
			Sys_MouseMove(35, 200);
		} else if ( SelItem==-1 ) {
			Sys_MouseMove(427, 200);
		}
	} else if ( KeyCode==KEY_RIGHT ) {
		GetMouseButton();
		SkippingFlag = 0;
		if ( (SelItem>=1)&&(SelItem<=6) ) {
			Sys_MouseMove(231, (SelItem*37)+200);
		} else if ( (SelItem>=7)&&(SelItem<=12) ) {
			Sys_MouseMove(427, ((SelItem-6)*37)+200);
		} else if ( SelItem==0 ) {
			Sys_MouseMove(427, 200);
		} else if ( SelItem==-1 ) {
			Sys_MouseMove(35, 200);
		}
	} else if ( KeyCode==KEY_BTN0 ) {
		ctrl = 1;
	} else if ( KeyCode==KEY_BTN1 ) {
		ctrl = 2;
		Sys_MouseButton();
	}
	KeyCode = 0;

	GetMousePos(&x, &y);
	for (i=0; i<21; i++) {
		if ( (x>=(((i/7)*196)+31))&&(x<(((i/7)*196)+219))&&(y>=(((i%7)*37)+186))&&(y<(((i%7)*37)+215)) ) {
			SelItem = i;
			if ( SelItem==7 ) SelItem = old;
			else if ( SelItem>7 ) SelItem--;
			break;
		}
	}

	if ( old!=SelItem ) {
		if ( old!=-1 ) {
			if ( old<7 ) {
				x = 31;
				y = old*37+186;
			} else {
				x = ((old+1)/7)*196+31;
				y = ((old+1)%7)*37+186;
			}
			Sys_ExchangePixel(x, y, 188, 29, x, y);
			Sys_Update(x, y, x+187, y+28);
		}
		if ( SelItem!=-1 ) {
			if ( SelItem<7 ) {
				x = 31;
				y = SelItem*37+186;
			} else {
				x = ((SelItem+1)/7)*196+31;
				y = ((SelItem+1)%7)*37+186;
			}
			Sys_ExchangePixel(x, y, 188, 29, x, y);
			Sys_Update(x, y, x+187, y+28);
		}
	}
	if ( GetMouseButton() ) {
		if ( (x>=499)&&(x<547)&&(y>=55)&&(y<103) ) ctrl = 1;
		else if ( (x>=558)&&(x<606)&&(y>=55)&&(y<103) ) ctrl = 2;
		else if ( (x>=528)&&(x<576)&&(y>=106)&&(y<154) ) ctrl = 3;
		if ( ctrl ) {
			switch ( BGMCtrl ) {
				case 1: Sys_ExchangePixel(499, 55, 48, 48, 499, 55); break;
				case 2: Sys_ExchangePixel(558, 55, 48, 48, 558, 55); break;
				case 3: Sys_ExchangePixel(528, 106, 48, 48, 528, 106); break;
			}
			switch ( ctrl ) {
				case 1: Sys_ExchangePixel(499, 55, 48, 48, 499, 55); break;
				case 2: Sys_ExchangePixel(558, 55, 48, 48, 558, 55); break;
				case 3: Sys_ExchangePixel(528, 106, 48, 48, 528, 106); break;
			}
			Sys_Update(499, 55, 605, 153);
			BGMCtrl = ctrl;
			if ( (ctrl==1)&&(SelItem!=-1) ) {
				// IiIj
				SelMaxItem = 0;
				Sys_SetFlag(FLAG_COUNT, SelResult, SelItem);		// ʂJE^tOɃZbgi1`nj
				SysState = SYS_STATE_NONE;
			} else if ( ctrl==2 ) {
				SelMaxItem = 0;
				Sys_SetFlag(FLAG_COUNT, SelResult, 41);			// Stop
				SysState = SYS_STATE_NONE;
			} else if ( ctrl==3 ) {
				BGMModeFlag = 0;
				SelMaxItem = 0;
				Sys_SetFlag(FLAG_COUNT, SelResult, 42);			// Return
				Sys_ClearBG();
				Sys_StartEffect(7);
			}
		}
	}
}


// -----------------------------------------------------------------------------------------
//   bZ[WEBhE
// -----------------------------------------------------------------------------------------

#define MESWINPIXEL			\
{					\
	int r, g, b;			\
	r = g = b = *dst;		\
	b &= 0x001f;			\
	g &= 0x07e0;			\
	r &= 0xf800;			\
	b = ((b*WINB)>>8)&0x001f;	\
	g = ((g*WING)>>8)&0x07e0;	\
	r = ((r*WINR)>>8)&0xf800;	\
	*dst = (r|g|b);			\
	dst++;				\
}


void Sys_DrawWindowFrame(int x1, int y1, int x2, int y2, int scr)
{
	static const int WINEDGEX[9] = {9,7,5,4,3,2,2,1,1};
	int x, y, i, pad, height, width;
	unsigned short *dst, *src;

	height = y2-y1-17;
	width  = x2-x1+1;
	dst = (unsigned short*)GetPixMapAdrOffscreen(hScr[scr]);
	dst += y1*640+x1;
	pad = 640-width;
	for (y=0; y<9; y++) {
		dst += WINEDGEX[y];
		i = width-(WINEDGEX[y]<<1);
		for (x=0; x<i; x++) {
			MESWINPIXEL
		}
		dst += pad;
		dst += WINEDGEX[y];
	}
	for (y=0; y<height; y++) {
		for (x=0; x<width; x++) {
			MESWINPIXEL
		}
		dst += pad;
	}
	for (y=8; y>=0; y--) {
		dst += WINEDGEX[y];
		i = width-(WINEDGEX[y]<<1);
		for (x=0; x<i; x++) {
			MESWINPIXEL
		}
		dst += pad;
		dst += WINEDGEX[y];
	}
}


void Sys_DrawMessageWindow(void)
{
	int x, y;
	unsigned short *dst, *src;

	if ( MesWinFlag ) {
		// Window͊ɕ`ς
		dst = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr]);
		dst += WINY*640+WINX;
		src = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^1]);
		src += WINY*640+WINX;
		for (y=0; y<WINH; y++) {
			for (x=0; x<WINW; x++) {
				*dst++ = *src++;
			}
			dst += (640-WINW);
			src += (640-WINW);
		}
	} else {
		Sys_DrawWindowFrame(WINX, WINY, WINX+WINW-1, WINY+WINH-1, PrimScr);

		// `Window2ndobt@ɃRs[
		dst = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^1]);
		dst += WINY*640+WINX;
		src = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr]);
		src += WINY*640+WINX;
		for (y=0; y<WINH; y++) {
			for (x=0; x<WINW; x++) {
				*dst++ = *src++;
			}
			dst += (640-WINW);
			src += (640-WINW);
		}
		MesWinFlag = 1;
	}
}


void Sys_HideWindow(void)
{
	int x, y;
	unsigned short *dst, *src;

	if ( MesWinFlag ) {		// Window\ĂΎs
		Sys_DrawScreen();
		dst = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr]);
		dst += WINY*640+WINX;
		src = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^1]);
		src += WINY*640+WINX;
		for (y=0; y<WINH; y++) {
			for (x=0; x<WINW; x++) {
				*dst++ = *src++;
			}
			dst += (640-WINW);
			src += (640-WINW);
		}
		MesWinFlag = 0;
	}
}


int Sys_TempHideWindow(void)
{
	int ret = 0;

	if ( MesWinFlag ) {		// Window\ĂΎs
		if ( (sysdata.CfgFontMode)&&(!VGAFlag) ) {
			memcpy((char*)GetPixMapAdrOffscreen(hHideScr), (char*)GetPixMapAdrOffscreen(hBackScr), 320*240*2);
		}
		ret = 1;
		Sys_DrawScreen();
		MesWinFlag = 1;		// DrawScreenŃtÔ
		PrimScr ^= 1;
		Sys_Update(0, 0, 639, 479);
	}
	return ret;
}


void Sys_TempRedrawWindow(void)
{
	Sys_DrawWindowFrame(WINX, WINY, WINX+WINW-1, WINY+WINH-1, PrimScr);
	PrimScr ^= 1;
	if ( (sysdata.CfgFontMode)&&(!VGAFlag) ) {
		memcpy((char*)GetPixMapAdrOffscreen(hBackScr), (char*)GetPixMapAdrOffscreen(hHideScr), 320*240*2);
		Sys_Update2(0, 0, 639, 479);
	} else {
		Sys_Update(0, 0, 639, 479);
	}
}


// -----------------------------------------------------------------------------------------
//   tEBhEiEj̕\
// -----------------------------------------------------------------------------------------
void Sys_StartDateWindow(void)
{
	int n;

	Sys_DrawWindowFrame(462, 10, 629, 97, PrimScr^1);
	n = savedata.flag[FLAG_COUNT][0];
	Sys_PutBitmapItem2((n/10)*19+256, 160, 18, 19, 472, 20);		// 
	Sys_PutBitmapItem2((n%10)*19+256, 160, 18, 19, 488, 20);
	Sys_PutBitmapItem2(446, 160, 18, 19, 502, 29);				// /
	n = savedata.flag[FLAG_COUNT][1];
	Sys_PutBitmapItem2((n/10)*19+256, 160, 18, 19, 516, 38);		// 
	Sys_PutBitmapItem2((n%10)*19+256, 160, 18, 19, 532, 38);
	n = savedata.flag[FLAG_COUNT][4];
	Sys_PutBitmapItem2((n%4)*72+256, (n/4)*24+228, 71, 23, 552, 26);	// j
	n = savedata.flag[FLAG_COUNT][2];
	Sys_PutBitmapItem2((n/12)*48+256, 276, 47, 19, 472, 70);		// AM/PM
	n %= 12;
	if ( n>9 )
		Sys_PutBitmapItem2(280, 296, 23, 23, 522, 66);			// 
	Sys_PutBitmapItem2((n%10)*24+256, 296, 23, 23, 543, 66);
	Sys_PutBitmapItem2(496, 296, 23, 23, 564, 66);				// :
	n = savedata.flag[FLAG_COUNT][3];
	Sys_PutBitmapItem2((n/10)*24+256, 296, 23, 23, 585, 66);		// 
	Sys_PutBitmapItem2((n%10)*24+256, 296, 23, 23, 606, 66);

	DateState = 1;
	DateBase = Sys_GetCurrentTimer();
}


static void Sys_DrawDate(void)
{
	unsigned int t;
	int x, y;
	unsigned short *dst, *src, *d, *s, c;

	t = Sys_GetCurrentTimer()-DateBase;
	if ( (t>=200)&&(t<100000) ) {
		dst = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr]);
		src = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^1]);
		if ( DateState<5 ) {
			dst += (10+EFFADEY[DateState-1])*640+462+EFFADEX[DateState-1];
			src += (10+EFFADEY[DateState-1])*640+462+EFFADEX[DateState-1];
			for (y=EFFADEY[DateState-1]; y<88; y+=2) {
				d = dst;
				s = src;
				for (x=EFFADEX[DateState-1]; x<168; x+=2) {
					c = *d;
					*d = *s;
					*s = c;
					d += 2;
					s += 2;
				}
				dst += 1280;
				src += 1280;
			}
			Sys_Update(462, 10, 629, 97);
		} else if( DateState>=20 ) {
			dst += (10+EFFADEY[23-DateState])*640+462+EFFADEX[23-DateState];
			src += (10+EFFADEY[23-DateState])*640+462+EFFADEX[23-DateState];
			for (y=EFFADEY[23-DateState]; y<88; y+=2) {
				d = dst;
				s = src;
				for (x=EFFADEX[23-DateState]; x<168; x+=2) {
					c = *d;
					*d = *s;
					*s = c;
					d += 2;
					s += 2;
				}
				dst += 1280;
				src += 1280;
			}
			Sys_Update(462, 10, 629, 97);
		}
		DateBase = Sys_GetCurrentTimer();
		DateState++;
		if ( DateState>=24 ) DateState = 0;
	}
}


void Sys_RedrawDate(void)
{
	int i, x, y, n;
	unsigned short *dst, *src, *d, *s, c;
	short state = DateState;
	unsigned int t = DateBase;
	Sys_StartDateWindow();
	DateState = state;
	DateBase = t;
	if ( DateState<=4 )
		n = DateState-1;
	else if ( DateState>=20 )
		n = 23-DateState;
	else
		n = -1;
	for (i=0; i<=n; i++) {
		dst = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr]);
		src = (unsigned short*)GetPixMapAdrOffscreen(hScr[PrimScr^1]);
		dst += (10+EFFADEY[i])*640+462+EFFADEX[i];
		src += (10+EFFADEY[i])*640+462+EFFADEX[i];
		for (y=EFFADEY[i]; y<88; y+=2) {
			d = dst;
			s = src;
			for (x=EFFADEX[i]; x<168; x+=2) {
				c = *d;
				*d = *s;
				*s = c;
				d += 2;
				s += 2;
			}
			dst += 1280;
			src += 1280;
		}
	}
}


// -----------------------------------------------------------------------------------------
//   }EX^J[\L[
// -----------------------------------------------------------------------------------------
int GetMouseButton(void)
{
	int ret = MouseButtonFlag;
	MouseButtonFlag = 0;
	return ret;
}


void GetMousePos(short* x, short* y)
{
	*x = MouseX;
	*y = MouseY;
}


void Sys_MouseMove(short x, short y)
{
	MouseX = x;
	MouseY = y;
	KeyCode = 0;
}


void Sys_MouseButton(void)
{
	if ( savedata.waitskipflag ) {
		MouseButtonFlag = 1;
	}
	SkippingFlag = 0;
}


void Sys_ToggleSkip(void)
{
	if ( savedata.waitskipflag ) {
		SkippingFlag ^= 1;
	}
}


void Sys_KeyUp(void)
{
	KeyCode = KEY_UP;
	SkippingFlag = 0;
}


void Sys_KeyDown(void)
{
	KeyCode = KEY_DOWN;
	SkippingFlag = 0;
}


void Sys_KeyRight(void)
{
	KeyCode = KEY_RIGHT;
}


void Sys_KeyLeft(void)
{
	KeyCode = KEY_LEFT;
}


void Sys_KeyBtn0(void)
{
	KeyCode = KEY_BTN0;
}


void Sys_KeyBtn1(void)
{
	KeyCode = KEY_BTN1;
}


void Sys_StartKeyWait(void)
{
	SysState = SYS_STATE_CLICKWAIT;
}


// -----------------------------------------------------------------------------------------
//   V[^|C^ύXiZ[uf[^pj
// -----------------------------------------------------------------------------------------

void Sys_ChangePos(unsigned short pos)
{
	savedata.curpos = pos;
}

void Sys_ChangeSeen(char* seen)
{
	strcpy(savedata.curseen, seen);
}


// -----------------------------------------------------------------------------------------
//   BGM֘A
// -----------------------------------------------------------------------------------------
void Sys_StartBGM(short trk, short loop)
{
	savedata.curbgm = trk;
	savedata.curbgmloop = loop;
	Sound_CD_Play(trk, loop);
}

void Sys_StopBGM(short fade)
{
	savedata.curbgm = 0;
	if ( fade )
		Sound_CD_FadeOut(15);
	else
		Sound_CD_Stop();
}



// -----------------------------------------------------------------------------------------
//   eVXeXe[gs
// -----------------------------------------------------------------------------------------
int Sys_InEffect(void)
{
	int ret = FALSE, n, size;
	unsigned int t, x, y;
	const short daypad[] = {0, 4, 0, 0, 3, 0, 0, 0, 0, 0, 0, -1, 1};

	if ( !ItemBitmap ) {
		ItemBitmap = ArcFile_Load("ETC23", &size);
	}

	switch ( SysState ) {
		case SYS_STATE_NONE:
			break;
		case SYS_STATE_EFFECT:
			Sys_Effect();
			if ( SysState!=SYS_STATE_NONE ) ret = TRUE;
			break;
		case SYS_STATE_WAIT:
			t = Sys_GetCurrentTimer()-WaitBase;
			if ( (t>=CurWait)&&(t<100000) ) {
				CurWait = 0;
				SysState = SYS_STATE_NONE;
			} else if ( (GetMouseButton())||(SkippingFlag) ) {
				CurWait = 0;
				SysState = SYS_STATE_NONE;
			} else {
				ret = TRUE;
			}
			break;
		case SYS_STATE_MESSAGE:
			if ( (GetMouseButton())||(SkippingFlag) ) {
				Sys_MessageFast();
				if ( SysState!=SYS_STATE_NONE ) ret = TRUE;
			} else {
				Sys_Message();
				ret = TRUE;
			}
			break;
		case SYS_STATE_MESCLICKWAIT:
			if ( (KeyCode==KEY_UP)||(KeyCode==KEY_DOWN) ) {
				if ( LogStart!=LogEnd ) {
					CurLogPage = LogEnd-1;
					if ( CurLogPage<0 ) CurLogPage = MAXLOG-1;
					Sys_StartLog();
				}
				KeyCode = 0;
			} else if ( (GetMouseButton())||(SkippingFlag) ) {
				SysState = SYS_STATE_MESSAGE;
				// NbN҂ACRĂ
				Sys_PutBitmapItem(224, 0, 32, 32, 560, 432, 0);
				Sys_Update(560, 432, 560+31, 432+31);
			} else {
				// NbN҂ACR
				t = Sys_GetCurrentTimer()-AnmWaitBase;
				if ( (t>=180)&&(t<100000) ) {
					Sys_PutBitmapItem(AnmCount*32, 0, 32, 32, 560, 432, 0);
					Sys_Update(560, 432, 560+31, 432+31);
					AnmCount = (AnmCount+1)%7;
					AnmWaitBase = Sys_GetCurrentTimer();
				}
			}
			ret = TRUE;
			break;
		case SYS_STATE_LOGWAIT:
			if ( KeyCode==KEY_UP ) {
				if ( CurLogPage!=LogStart ) {
					CurLogPage--;
					if ( CurLogPage<0 ) CurLogPage = MAXLOG-1;
					Sys_StartLog();
				}
			} else if ( KeyCode==KEY_DOWN ) {
				CurLogPage = (CurLogPage+1)%MAXLOG;
				if ( CurLogPage!=LogEnd ) {
					Sys_StartLog();
				} else {
					CurLogPage--;
					if ( CurLogPage<0 ) CurLogPage = MAXLOG-1;
				}
			} else if ( GetMouseButton() ) {
				MesX = 0;
				MesY = 0;
				MesIndent = 0;
				MsgPtr = MessageBuffer;
				SysState = SYS_STATE_MESSAGE;
				Sys_DrawMessageWindow();
				Sys_MessageFast();
			}
			KeyCode = 0;
			ret = TRUE;
			break;
		case SYS_STATE_CLICKWAIT:
			if ( (GetMouseButton())||(SkippingFlag) ) {
				SysState = SYS_STATE_NONE;
			} else {
				ret = TRUE;
			}
			break;
		case SYS_STATE_SELECT:
			Sys_Select();
			ret = TRUE;
			break;
		case SYS_STATE_MAINMENUFADE:
			Sys_Effect();
			if ( SysState==SYS_STATE_NONE ) {
				SysState = SYS_STATE_MAINMENU;
				Sys_SetBG("ETC01");
				Sys_LoadBG();
				savedata.curbg[0] = 0;
			}
			ret = TRUE;
			break;
		case SYS_STATE_MAINMENU:
			Sys_TitleMenu();
			ret = TRUE;
			break;
		case SYS_STATE_APPENDMENUFADE:
			Sys_Effect();
			if ( SysState==SYS_STATE_NONE ) {
				SysState = SYS_STATE_APPENDMENU;
				Sys_SetBG("ETC03");
				Sys_LoadBG();
				savedata.curbg[0] = 0;
			}
			ret = TRUE;
			break;
		case SYS_STATE_APPENDMENU:
			Sys_AppendixMenu();
			ret = TRUE;
			break;
		case SYS_STATE_CGCHARMENUFADE:
			Sys_Effect();
			if ( SysState==SYS_STATE_NONE ) {
				SysState = SYS_STATE_CGCHARMENU;
				Sys_PutJpegItem(  0, 516, 100, 100, 117, 259, 1);
				Sys_PutJpegItem(101, 516, 100, 100, 219, 259, 1);
				Sys_PutJpegItem(202, 516, 100, 100, 321, 259, 1);
				Sys_PutJpegItem(303, 516, 100, 100, 117, 361, 1);
				Sys_PutJpegItem(404, 516, 100, 100, 219, 361, 1);
				Sys_PutJpegItem(505, 516, 100, 100, 321, 361, 1);
				Sys_PutJpegItem(606, 516, 100, 100, 423, 361, 1);
			}
			ret = TRUE;
			break;
		case SYS_STATE_CGCHARMENU:
			Sys_CGCharMenu();
			ret = TRUE;
			break;
		case SYS_STATE_CGNUMMENUFADE:
			Sys_Effect();
			if ( SysState==SYS_STATE_NONE ) {
				SysState = SYS_STATE_CGNUMMENU;
			}
			ret = TRUE;
			break;
		case SYS_STATE_CGNUMMENU:
			Sys_CGSelMenu();
			ret = TRUE;
			break;
		case SYS_STATE_BGMMENUFADE:
			if ( !BGMModeFlag ) {
				Sys_Effect();
				if ( SysState==SYS_STATE_NONE ) {
					SysState = SYS_STATE_BGMMENU;
					Sys_SetBG("ETC15");
					Sys_LoadBG();
					savedata.curbg[0] = 0;
					BGMModeFlag = 1;
				}
			} else {
				SysState = SYS_STATE_BGMMENU;
			}
			ret = TRUE;
			break;
		case SYS_STATE_BGMMENU:
			Sys_BGMMenu();
			ret = TRUE;
			break;
		case SYS_STATE_LOADMENU:
			break;
		case SYS_STATE_APNDMENU:
			break;
		case SYS_STATE_CHARMENU:
			break;
		case SYS_STATE_MUSICMENU:
			break;
		case SYS_STATE_CAL_FADEIN:
			Sys_Effect();
			if ( SysState==SYS_STATE_NONE ) {
				SysState = SYS_STATE_CAL_WAIT;
				AnmWaitBase = Sys_GetCurrentTimer();
			}
			ret = TRUE;
			break;
		case SYS_STATE_CAL_WAIT:
			t = Sys_GetCurrentTimer()-AnmWaitBase;
			if ( (GetMouseButton())||(SkippingFlag) ) {
				SysState = SYS_STATE_CAL_ANIMATION;
				AnmCount = 0;
				AnmWaitBase = Sys_GetCurrentTimer();
			}
			if ( (t>=600)&&(t<100000) ) {
				SysState = SYS_STATE_CAL_ANIMATION;
				AnmCount = 0;
				AnmWaitBase = Sys_GetCurrentTimer();
			}
			ret = TRUE;
			break;
		case SYS_STATE_CAL_ANIMATION:
			t = Sys_GetCurrentTimer()-AnmWaitBase;
			if ( (GetMouseButton())||(SkippingFlag) ) {
				AnmCount = 4;
				t = 100;
			}
			if ( (t>=50)&&(t<100000) ) {
				n = daypad[savedata.flag[FLAG_COUNT][0]] + savedata.flag[FLAG_COUNT][1];
				x = (n%7)*68+85;
				y = (n/7)*59+131;
				Sys_PutBitmapItem(AnmCount*66+128, 340, 66, 57, x, y, 0);
				Sys_Update(x, y, x+65, y+56);
				AnmCount++;
				AnmWaitBase = Sys_GetCurrentTimer();
				if ( AnmCount==5 ) {
					SysState = SYS_STATE_CAL_CLICKWAIT;
				}
			}
			ret = TRUE;
			break;
		case SYS_STATE_CAL_CLICKWAIT:
			if ( (GetMouseButton())||(SkippingFlag) ) {
				Sys_ClearBG();
				Sys_StartEffect(6);
			}
			ret = TRUE;
			break;
	}

	if ( DateState ) Sys_DrawDate();
	Sound_CD_CheckPlay();

	return ret;
}


// -----------------------------------------------------------------------------------------
//   Z[u[h
// -----------------------------------------------------------------------------------------
void Sys_LoadSystemFlags(char* drv)
{
	FILE* fp;
	unsigned char buf[0x1000];
	int i;

	sprintf(SaveFile, "%s:\\ONE\\WLK1.SAV", drv);
	fp = fopen(SaveFile, "rb");
	if ( !fp ) {
		fp = fopen(SaveFile, "w");
		if ( fp ) {
			memset(buf, 0, 0x1000);
			for (i=0; i<(MAXSAVEFILE+5); i++) {		// MAXSAVEDATA{VXetOi4ubNj{W[f[^
				fwrite((char*)buf, 1, 0x1000, fp);
			}
			fclose(fp);
//			Error("System : Z[ut@C܂.");
			return;
		}
	}

	fseek(fp, 0, 0);
	fread((char*)(&sysdata), 1, sizeof(sysdata), fp);
	fclose(fp);
}


void Sys_SaveSystemFlags(void)
{
	FILE* fp;
	fp = fopen(SaveFile, "r+");
	if ( fp ) {
		fseek(fp, 0, 0);
		fwrite((char*)(&sysdata), sizeof(sysdata), 1, fp);
		fclose(fp);
	}
}


void Sys_Load(int n)
{
	FILE* fp;
	char bg[16];
	MESSAGE	msg;
	const char s[] = "W[܂.";

	if ( n<0 ) return;
	if ( n==MAXSAVEFILE ) {
		if ( !sysdata.ResumeFlag ) return;
		sysdata.ResumeFlag = 0;
		msg.CommonMsg.MessageID = AlboxDispOpenID;
		AlertExecStr( &msg, (unsigned char*)s, ALB_CENTER, NO_BTN );
	} else {
		if ( !sysdata.si[n].sm ) return;
	}

	if ( n!=MAXSAVEFILE )
		sysdata.LastSaveLoad = n;
	Sys_SaveSystemFlags();

	if ( MesWinFlag ) {		// Window\ĂΎs
		Sys_DrawScreen();
		PrimScr ^= 1;
		Sys_Update(0, 0, 639, 479);
	}

	fp = fopen(SaveFile, "rb");
	if ( fp ) {
		fseek(fp, n*0x1000+0x4000, 0);
		fread((char*)(&savedata), 1, sizeof(savedata), fp);
		fclose(fp);
	}
	Sys_Reset();
	Scn_Reset(savedata.curpos, savedata.curseen);
	strcpy(bg, savedata.curbg);
	strcpy(savedata.curbg, "DUMMY");
	Sys_SetBG(bg);
	Sys_DrawScreen();
	Sys_StartEffect(6);
	Sound_CD_Play(savedata.curbgm, savedata.curbgmloop);

	if ( n==MAXSAVEFILE ) {
		msg.CommonMsg.MessageID = AlboxDispCloseID;
		AlertExecStr( &msg, NULL, 0, 0 );
	}
}


void Sys_Save(int n)
{
	FILE* fp;
	TIME t;

	if ( n<0 ) return;
	if ( n==MAXSAVEFILE ) {
		if ( !strcmp(savedata.curseen, "INIT") ) return;
		sysdata.ResumeFlag = 1;
	}

	fp = fopen(SaveFile, "r+");
	if ( fp ) {
		fseek(fp, n*0x1000+0x4000, 0);
		fwrite((char*)(&savedata), 1, sizeof(savedata), fp);
		fclose(fp);

		LocalTimeRead(&t, CURRENT_CITY_ID);
		sysdata.si[n].sm = (t.TArray[3]&15);
		sysdata.si[n].sd = (t.TArray[2]>>3);
		sysdata.si[n].sh = ((t.TArray[2]&7)<<2)+((t.TArray[1]>>6)&3);
		sysdata.si[n].sn = (t.TArray[1]&0x3f);
		sysdata.si[n].m = savedata.flag[FLAG_COUNT][0];
		sysdata.si[n].d = savedata.flag[FLAG_COUNT][1];
		sysdata.si[n].h = savedata.flag[FLAG_COUNT][2];
		sysdata.si[n].n = savedata.flag[FLAG_COUNT][3];
		sysdata.si[n].w = savedata.flag[FLAG_COUNT][4];
		if ( n!=MAXSAVEFILE )
			sysdata.LastSaveLoad = n;
		Sys_SaveSystemFlags();
	}
}


void Sys_GetSaveDataTitle(int n, char* s)
{
	static const char* const wk[] = {"","","","","","","y"};
	if ( (n<0)||(!sysdata.si[n].sm) ) {
		sprintf(s, "%02d:--/--(--:--) ------ No Data ------", n+1);
	} else {
		if ( !sysdata.si[n].m ) {
			// 
			sprintf(s, "%02d:%2d/%2d(%02d:%02d) ----(--) ----", n+1,
				sysdata.si[n].sm, sysdata.si[n].sd, sysdata.si[n].sh, sysdata.si[n].sn);
		} else {
			sprintf(s, "%02d:%2d/%2d(%02d:%02d) %2d%2d(%s) %2d%2d", n+1,
				sysdata.si[n].sm, sysdata.si[n].sd, sysdata.si[n].sh, sysdata.si[n].sn,
				sysdata.si[n].m, sysdata.si[n].d, wk[sysdata.si[n].w],
				sysdata.si[n].h, sysdata.si[n].n);
		}
	}
}


void Sys_BackToTitle(void)
{
	char bg[16], fname[10], lname[10];

	if ( MesWinFlag ) {		// Window\ĂΎs
		Sys_DrawScreen();
		PrimScr ^= 1;
		Sys_Update(0, 0, 639, 479);
	}

	// Z[uf[^l
	strcpy(fname, savedata.firstname);
	strcpy(lname, savedata.lastname);
	memset((char*)(&savedata), 0, sizeof(savedata));
	strcpy(savedata.firstname, fname);
	strcpy(savedata.lastname, lname);
	strcpy(savedata.curseen, "INIT");
	savedata.curpos = 0;
	savedata.waitskipflag = 1;

	Sound_CD_FadeOut(15);
	Sys_Reset();
	Scn_Title();
	strcpy(bg, savedata.curbg);
	strcpy(savedata.curbg, "DUMMY");
	Sys_SetBG(bg);
	Sys_DrawScreen();
	Sys_StartEffect(6);
}


// -----------------------------------------------------------------------------------------
//   RtBO֘A
// -----------------------------------------------------------------------------------------
void Sys_SetSkipMode(short sw)
{
	sysdata.CfgSkipMode = sw;
}

void Sys_SetEffectMode(short sw)
{
	sysdata.CfgEffectMode = sw;
}

void Sys_SetFontMode(short sw)
{
	sysdata.CfgFontMode = sw;
}

void Sys_SetBGMVolume(short sw)
{
	sysdata.CfgBGMVolume = sw;
	Sound_CD_MasterVol(sw);
}


short Sys_GetSkipMode(void)
{
	return sysdata.CfgSkipMode;
}

short Sys_GetEffectMode(void)
{
	return sysdata.CfgEffectMode;
}

short Sys_GetFontMode(void)
{
	return (sysdata.CfgFontMode)&&(!VGAFlag);
}

short Sys_GetBGMVolume(void)
{
	return sysdata.CfgBGMVolume;
}

short Sys_GetLastSaveData(void)
{
	if ( (sysdata.LastSaveLoad<0)||(sysdata.LastSaveLoad>=MAXSAVEFILE) )
		return 0;
	else
		return sysdata.LastSaveLoad;
}

