/*=======================================================================
  xakane for Zaurus
  Copyright 2001, K.Takagi(Kenjo)
=======================================================================*/
/* ================================================================
   ***** Original Code Copyright ******
 
   xakane  --- ONE ` for bright season for X ---
   (c) Copyright 2000, 2001 Nao <nao@sore.totto.to>
   All rights reserved.
================================================================ */

#ifndef _zakane_system_h
#define _zakane_system_h

#include <zheaders.h>

extern 	char		VGAFlag;
extern	char		TerminateFlag;
extern WINDOWHD		hMainWnd;
extern WINDOWHD		hBackScr;
extern WINDOWHD		hScr[2];

void  Error(char* mes);
int   YesNo(char* mes);

int   Sys_Init(void);
void  Sys_Cleanup(void);
void  Sys_Terminate(void);

void Sys_Update(int x1, int y1, int x2, int y2);
void  Sys_Redraw(void);
unsigned char* Sys_LoadScript(char* file, int* size);
void  Sys_LoadBG(void);
void  Sys_LoadChr(char* file, int pos);
void  Sys_ClearBG(void);
void  Sys_SetBG(char* file);
void  Sys_SetChr(char* file, unsigned char num, unsigned char pos);
void  Sys_DrawScreen(void);

void  Sys_SetFlag(int flagtype, int num, short val);
short Sys_GetFlag(int flagtype, int num);

void  Sys_PushStack(unsigned short* pos, char* seen);
void  Sys_PopStack(unsigned short* pos, char* seen);

void Sys_StartMessage(char* mes, unsigned short pos);
void Sys_AddSelect(char* mes);
void Sys_StartSelect(short result);
void  Sys_SetWaitSkip(char sw);
void  Sys_StartWait(int t);
void  Sys_StartEffect(int n);
int   Sys_InEffect(void);

void  Sys_DrawMessageWindow();
void  Sys_DrawWindowFrame(int x1, int y1, int x1, int y1, int scr);
void  Sys_HideWindow();
int Sys_TempHideWindow(void);
void Sys_TempRedrawWindow(void);

void Sys_StartDateWindow(void);
void Sys_DrawDate(void);

int GetMouseButton(void);
void GetMousePos(short* x, short* y);
void Sys_MouseMove(short x, short y);
void Sys_MouseButton(void);
void Sys_ToggleSkip(void);
void Sys_KeyUp(void);
void Sys_KeyDown(void);

void Sys_ChangePos(unsigned short pos);
void Sys_ChangeSeen(char* seen);

unsigned int Sys_GetCurrentTimer(void);

void Sys_LoadSystemFlags(char* drv);
void Sys_SaveSystemFlags(void);
void Sys_Load(int n);
void Sys_Save(int n);
void Sys_GetSaveDataTitle(int n, char* s);
void Sys_BackToTitle(void);

short Sys_GetLastSaveData(void);

enum {
	FLAG_SWITCH = 0,
	FLAG_COUNT,
	FLAG_SYSTEM
};

enum {
	SYS_STATE_NONE = 0,
	SYS_STATE_EFFECT,
	SYS_STATE_WAIT,
	SYS_STATE_MESSAGE,
	SYS_STATE_MESCLICKWAIT,
	SYS_STATE_CLICKWAIT,
	SYS_STATE_SELECT,
	SYS_STATE_MAINMENU,
	SYS_STATE_MAINMENUFADE,
	SYS_STATE_LOADMENU,
	SYS_STATE_APNDMENU,
	SYS_STATE_CHARMENU,
	SYS_STATE_MUSICMENU,
	SYS_STATE_CAL_FADEIN,
	SYS_STATE_CAL_ANIMATION,
	SYS_STATE_CAL_CLICKWAIT,
	SYS_STATE_CAL_WAIT,
	SYS_STATE_LOGWAIT,
	SYS_STATE_APPENDMENU,
	SYS_STATE_APPENDMENUFADE,
	SYS_STATE_CGCHARMENU,
	SYS_STATE_CGCHARMENUFADE,
	SYS_STATE_CGNUMMENU,
	SYS_STATE_CGNUMMENUFADE,
	SYS_STATE_BGMMENU,
	SYS_STATE_BGMMENUFADE
};

#define KEY_NONE  0
#define KEY_UP    1
#define KEY_DOWN  2
#define KEY_LEFT  3
#define KEY_RIGHT 4
#define KEY_BTN0  5
#define KEY_BTN1  6

#define EF_FADE   6
#define EF_SCROLL 101
#define EF_IMM    102


#endif
