#contoroldef=Crimson.ctl
#resourcefile=WLK1FM00
#label=mainscr
#part={
#partname=mainscr
#partfile=mainscr.ptr
#@x=0
#@y=0
#@width=10
#@height=10
#callback FormConstruct 0 
#callback FormRedisp 4 
void mainscrFormRedisp(APLFORMPTR AplForm, WINDOWHD WnHandle)
{
	if ( AkaneWork(AplForm)->RunningFlag ) Sys_Redraw();
}
#callback FormSetUp 25 
void mainscrFormSetUp(APLFORMPTR AplForm, MESSAGE* Message)
{
	COLOR	color;
	int flag = 1;

	AkaneWork(AplForm)->RunningFlag = 0;
	DisableFastTick();
	hMainWnd = AplForm->FormWnHandle;
	SetColorV(&color, BLACK);
	ClearWindow(AplForm->FormWnHandle, &color);

	if ( !Sys_Init() ) flag = 0;
	if ( flag ) {
		Sys_LoadSystemFlags(AkaneWork(AplForm)->DataDrive);
		Sound_Init(AkaneWork(AplForm)->DataDrive);
		Sys_SetBGMVolume(Sys_GetBGMVolume());
		if ( !ArcFile_Init(AkaneWork(AplForm)->DataDrive) ) flag = 0;
	}
	if ( flag ) {
		EnableFastTick();
		TerminateFlag = 0;
	} else {
		AplForm->IsExit = true;
	}
}
#callback FormEnd 18 
void mainscrFormEnd(APLFORMPTR AplForm, MESSAGE* Message)
{
	if ( AkaneWork(AplForm)->RunningFlag ) {
		Sys_Save(RESUME_DATA);
	}

	Sound_Cleanup();

	AkaneWork(AplForm)->RunningFlag = 0;
	DisableFastTick();
	Scn_Cleanup();
	ArcFile_Cleanup();
	Sys_Cleanup();
/*
	Message->CommonMsg.MessageID = AppliProcEndReqID;
	Message->AppliProcEndReq.AplFilter = AF_THIS_APPLI;
*/
}
#callback FormDeActivate 0 
#callback FormActivate 0 
#callback FormEventFilter 0 
#callback FormMenuAtrSet 0 
#callback FormMenuSelect 47 
void mainscrFormMenuSelect(APLFORMPTR AplForm, MESSAGE* Message, const MESSAGE* MenuMsg)
{
	MESSAGE LocalMessage;

	switch ( MenuMsg->MenuSelect.MenuID ) {
		case Menu_Save:
			AkaneWork(AplForm)->SaveLoadNo = -1;
			AkaneWork(AplForm)->SaveLoadFlag = SAVELOAD_SAVE;
			SetCtrlProperty(SaveLoadDlg, MDDLG_APL_WORK_PTR_PID, pValue, AplForm, AplForm->Control);
			LocalMessage.CommonMsg.MessageID = ToolOpenID;
			ControlCall(SaveLoadDlg, AplForm->Control, &LocalMessage);
			if ( AkaneWork(AplForm)->SaveLoadNo!=-1 ) {
				Sys_Save(AkaneWork(AplForm)->SaveLoadNo);
			}
			break;
		case Menu_Load:
			AkaneWork(AplForm)->SaveLoadNo = -1;
			AkaneWork(AplForm)->SaveLoadFlag = SAVELOAD_LOAD;
			SetCtrlProperty(SaveLoadDlg, MDDLG_APL_WORK_PTR_PID, pValue, AplForm, AplForm->Control);
			LocalMessage.CommonMsg.MessageID = ToolOpenID;
			ControlCall(SaveLoadDlg, AplForm->Control, &LocalMessage);
			if ( AkaneWork(AplForm)->SaveLoadNo!=-1 ) {
				Sys_Load(AkaneWork(AplForm)->SaveLoadNo);
			}
			break;
		case Menu_Config:
			SetCtrlProperty(ConfigDlg, MDDLG_APL_WORK_PTR_PID, pValue, AplForm, AplForm->Control);
			LocalMessage.CommonMsg.MessageID = ToolOpenID;
			ControlCall(ConfigDlg, AplForm->Control, &LocalMessage);
//			if ( Sys_TempHideWindow() )
//				Sys_TempRedrawWindow();
			break;
		case Menu_Title:
			Sys_BackToTitle();
			break;
		case Menu_Quit:
			if ( !YesNo("I܂. 낵łH") ) break;
			AkaneWork(AplForm)->RunningFlag = 0;
//			AplForm->IsExit = true;
			Message->CommonMsg.MessageID = AppliProcEndReqID;
			Message->AppliProcEndReq.AplFilter = AF_THIS_APPLI;
			break;
	}
	ReleasePenKey( DELETE_PEN_UP );
	DeleteEventMsg(KeyDownID);
	GetMouseButton();
}
#callback FormKeyExec 57 
void mainscrFormKeyExec(APLFORMPTR AplForm, MESSAGE* Message, const MESSAGE* KeyMsg)
{
	unsigned char* atr;
	MESSAGE LocalMessage;

	switch (KeyMsg->CommonMsg.MessageID)
	{
		case KeyDownID:
			if ( AkaneWork(AplForm)->HideWinFlag ) {
				Sys_TempRedrawWindow();
				AkaneWork(AplForm)->HideWinFlag = 0;
				DeleteEventMsg(OnBreakID);
			} else {
				switch(KeyMsg->KeyDown.KeyCode)
				{
				case KC_CURSOR_RIGHT:
					if ( KeyMsg->KeyDown.KeyRepeat==KEY_FIRST )
						Sys_MouseButton();
					break;
				case KC_CURSOR_LEFT:
					if ( KeyMsg->KeyDown.KeyRepeat==KEY_FIRST )
						Sys_ToggleSkip();
					break;
				case KC_CURSOR_UP:
					if ( KeyMsg->KeyDown.KeyRepeat==KEY_FIRST )
						Sys_KeyUp();
					break;
				case KC_CURSOR_DOWN:
					if ( KeyMsg->KeyDown.KeyRepeat==KEY_FIRST )
						Sys_KeyDown();
					break;
				case KC_DECIDE:
				case KC_NEXT:
					Sys_MouseButton();
					break;
				case KC_BACK:
				case KC_PREV:
/*					LocalMessage.CommonMsg.MessageID = GetPropertyID;
					LocalMessage.GetProperty.PropertyID = MENUATTR_PTR_PID;
					FormCallIconMenu( &LocalMessage, AplForm);
					atr = (unsigned char*)LocalMessage.GetProperty.Value.pValue;
					if ( *(atr+MenuSave-1) ) {
						Mouse_ButtonUp(1);
					} else {
*/
						if ( Sys_TempHideWindow() )
							AkaneWork(AplForm)->HideWinFlag = 1;
//					}
					break;

				default:
					break;
				}
			}
			break;
	}
}
#callback FormError 0 
#callback FormOtherEvent 65 
void mainscrFormOtherEvent(APLFORMPTR AplForm, MESSAGE* Message)
{
	MESSAGE LocalMessage;
	short x, y, i;

	x = (Message->PenDown.PositionX>>2);		/* QP Conversion */
	y = (Message->PenDown.PositionY>>2);
	if ( !VGAFlag ) {
		x <<= 1;		// QVGA -> VGA
		y <<= 1;
	}

	switch ( Message->CommonMsg.MessageID ) {
		case AppliActivateID:
			if ( !Message->AppliActivate.IsActivate ) {
				Sys_Save(RESUME_DATA);		// ꂶ[
				AkaneWork(AplForm)->RunningFlag = 1;
				AplForm->IsExit = true;
			}
			break;
		case PenDownID:
		case PenStillDownID:
			if ( !AkaneWork(AplForm)->HideWinFlag ) {
				Sys_MouseMove(x, y);
			}
			break;
		case PenUpID:
			if ( AkaneWork(AplForm)->HideWinFlag ) {
				Sys_TempRedrawWindow();
				AkaneWork(AplForm)->HideWinFlag = 0;
			} else {
				Sys_MouseMove(x, y);
				Sys_MouseButton();
			}
			break;
		case FastTickID:

if ( !AkaneWork(AplForm)->RunningFlag ) {
	if ( Scn_Init() ) {
		AkaneWork(AplForm)->RunningFlag = 1;
		Sys_Load(RESUME_DATA);
	} else {
		DisableFastTick();
		break;
	}
}
			if ( TerminateFlag ) {
				AkaneWork(AplForm)->RunningFlag = 0;
				AplForm->IsExit = true;
			} else if ( !AkaneWork(AplForm)->HideWinFlag ) {
				// uWIndowvs͒~
				LocalMessage.CommonMsg.MessageID = GetPropertyID;
				LocalMessage.GetProperty.PropertyID = WINDOW_HD_PID;
				FormCallIconMenu( &LocalMessage, AplForm);
				if( !LocalMessage.GetProperty.Value.ucValue ) {
					// j[JĂȂΎs
					for (i=0; i<3; i++) {
						Scn_Run();
						if ( TerminateFlag ) break;
					}
				}
			}
			break;
	}
}
#callback FormMenuFilter 0 
}
#part={
#partname=DummyCtrl
#partfile=DummyCtrl.ptr
#@x=0
#@y=0
#@width=50
#@height=30
#callback UC_CALL_BACK_PID 0 
}
#part={
#partname=SaveLoadDlg
#partfile=SaveLoadDlg.ptr
#@x=37
#@y=26
#@width=246
#@height=186
#callback UC_CALL_BACK_PID 0 
}
#part={
#partname=ConfigDlg
#partfile=ConfigDlg.ptr
#@x=67
#@y=40
#@width=186
#@height=160
#callback UC_CALL_BACK_PID 0 
}
#menu={
#src_attr=wlk1menu.atr
#label_attr=WLK1MAtr
#resfile_attr=WLK1MN00
#cmt_attr=""
#src_menu=wlk1menu.meu
#label_menu=WLK1Menu
#resfile_menu=WLK1MN00
#cmt_menu=""
}